{
 Common stuff (stringz, filez, date, time, etc.)

 (c) 1999-2000 Diman Petrov [2:5023/11.85, DimanInc@mail.ru]

 history:
 ~~~~~~~
 [12/03/00] - units Dp_Dos and Dp_Str were glued together into this shit
              ValueOfKey was removed
 [14/03/00] - HexL for VP fixed
 [16/03/00] - WordWrap added
              StreamEOF added
 [17/03/00] - WordWrap fixed
              Str2pChar and StrPNew added
 [18/03/00] - _Pos was erased
 [23/03/00] - XLats were erased
 [25/03/00] - Almost all functionz and procedurez were rewritten for using
              Huge and Short strings in VP. But I've tested just a little part
              of them, so be carefull
 [30/03/00] - FStrCopy was renamed to Buf2Str
 [10/04/00] - IO shit added (copied from unit Wizard (q) by sergey korowkin,
              2:6033/27)
 [02/05/00] + tStrings
 [07/02/00] + EndPos

 --- Dp_Dos history:
 [02/01/00] - StreamRead, StreamWrite added
              (copied from unit rObjects (c) raVen, 2:5010/150.16)
              Y2ToDouble, DoubleToY2 added
              (copied from unit skCommon (c) sergey korowkin, 2:6033/27)
 [05/01/00] - fMove little optimized,
              StreamRead, StreamWrite little fixed
 [09/01/00] - StreamReadCh added
 [16/01/00] - ExtractDriveNumber,
              ForceDir added
 [14/02/00] - fExists little fixed
 [27/02/00] - fCopy little fixed (date)
              GetCurrentUnixTime, GetCurrentDosTime added
              GetDateTime renamed to GetCurrentDateTime
              GetTempFileName added
 [10/03/00] - WholeParamStr for VP added
 ---

 --- Dp_Str history:
 [02/01/00] - tStCollection.GetItem, tStCollection.PutItem,
              tStCollection.Load, tStCollection.Store were added
 [07/01/00] - ReplaceStrings rewritten
 [15/01/00] - ReplaceStrings fixed [0 -> Low(A1)]
              Date2Str little changed
 [16/01/00] - BlockPos added (whose copyright ?)
              FStrCopy added
 [24/01/00] - ReplaceStringsEx added
 [14/02/00] - StrReplaceCS and StrReplaceCSEx added
 [15/02/00] - ReplaceStrings and ReplaceStringsEx were removed
 [16/02/00] - HexL rewritten on asm [(c) unknown]
 [23/02/00] - Trimz optimized
 [27/02/00] - Str2WeekDay and Str2Month added
 [28/02/00] - UnQuoteStr fixed
 [03/03/00] - GetPString added
 ---
}
{&Asm-,Delphi+,LocInfo+}
{$B-,D+,G+,F-,I-,L+,R-,V-}
Unit Dp_Comn;

{$IfDef MsDos}         {$Define DOS} {$EndIf}
{$IfDef Dpmi}          {$Define DOS} {$EndIf}
{$IfDef VirtualPascal} {$Define VP}  {$EndIf}

{$IfDef VP} {$IfOpt H+} {$Define VPH} {$EndIf} {$EndIf}

interface

uses
  {$IfDef VP} vpSysLow, vpUtils, {$EndIf}
  Dos, Objects, Strings,
  Dp_Basis;

const
  Months      : array[1..12]of String[3] =
    ('Jan','Feb','Mar','Apr','May','Jun',
     'Jul','Aug','Sep','Oct','Nov','Dec');
  RMonths     : array[1..12]of String[3] =
    ('','','','','','',
     '','','','','H','');
  FullMonths  : array[1..12]of String[9] =
    ('January','February','March','April','May','June',
     'July','August','September','October','November','December');
  RFullMonths : array[1..12]of String[8] =
    ('','ࠫ','','५','','',
     '','','','','H','');
  WDays       : array[0..6]of String[3] =
    ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
  RWDays      : array[0..6]of String[3] =
    ('','','','','','','');
  FullWDays   : array[0..6]of String[9] =
    ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
  RFullWDays  : array[0..6]of String[11] =
    ('ᥭ','쭨','୨','।',
     '⢥','⭨','㡡');

  SpaceCh   : tCharSet = [#09, #32];
  SpaceChEx : tCharSet = [#00, #09, #10, #13, #32, #255];

  DosCh     : tCharSet = [#0,':','\'];
  Days      : array[Boolean, 1..12] of Byte =
                ((31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31),
                 (31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31));

  MaxStringSize = {$IfDef VPH}
                   MaxLongint
                  {$Else}
                   pred(SizeOf(String))
                  {$EndIf};

type
  tStrProc = procedure(S: String);

var
  ExeDir: String;

{[ tStCollection ]ͻ}
type
  pStCollection = ^tStCollection;
  tStCollection = object(tCollection)
    constructor Load(var S: tStream);
    procedure FreeItem(Item: Pointer); virtual;
    function GetItem(var S: tStream): Pointer; virtual;
    procedure PutItem(var S: tStream; Item: Pointer); virtual;
    function IndexOf(Item: Pointer): xInt; virtual;
    function IndexOfNoCase(Item: Pointer): xInt;
    procedure Store(var S: tStream);
  end;
{ͼ}

{[ tStrings ]ͻ}
type
  pStrings = ^tStrings;
  tStrings = object(tCollection)
    procedure FreeItem(Item: Pointer); virtual;
  end;
{ͼ}

{}
function  N2Str     (Num: Longint): String;
function  N2FmtStr  (Num: Longint): String;
function  Str2Number(const S: String): Boolean;
function  Str2Int   (const S: String): Integer;
function  Str2Word  (const S: String): Word;
function  Str2xWord (const S: String): xWord;
function  Str2Long  (const S: String): Longint;
{}
function  Lead0(Num: Longint): String;
{}
function  HexB  (B: Byte): String;
function  HexW  (W: Word): String;
function  HexL  (L: Longint): String;
function  HexPtr(P: Pointer): String;
{}
function  BinB(B: Byte): String;
function  BinW(W: Word): String;
function  BinL(L: Longint): String;
{}
function  Hex2N(Hex: String): Longint;
function  Bin2N(Bin: String): Longint;
{}
function  UpCase(C: Char): Char;
function  LoCase(C: Char): Char;
function  StrUpCase(const S: String): String;
function  StrLoCase(const S: String): String;
procedure StrUpCaseEx(var S: String);
procedure StrLoCaseEx(var S: String);
{}
function  Str2Char  (const S: String; Index: Byte): Char;
function  Char2Str  (const C: Char): String;
function  Str2pChar (const Source: String): Pointer;
function  StrPNew   (const S: String): pChar;
function  pChar2Str (p: Pointer): String;
function  GetPString(p: Pointer): String;
function  Asciiz2Str(var Source): String;
function  Buf2Str   (var Source; Size: xWord): String;
{}
function  LTrimCh(S: String; C: tCharSet): String;
function  RTrimCh(S: String; C: tCharSet): String;
function  TrimCh (S: String; C: tCharSet): String;
function  LTrim(S: String): String;
function  RTrim(S: String): String;
function  Trim (S: String): String;
procedure LTrimEx(var S: String);
procedure RTrimEx(var S: String);
procedure TrimEx (var S: String);
function  _Trim  (S: String): String;
procedure _TrimEx(var S: String);
{}
function  LPadCh(S: String; C: Char; Len: xByte): String;
function  RPadCh(S: String; C: Char; Len: xByte): String;
function  LPad(S: String; Len: xByte): String;
function  RPad(S: String; Len: xByte): String;
{}
function  QuoteStr(S: String): String;
function  UnQuoteStr(S: String): String;
procedure QuoteStrEx(var S: String);
procedure UnQuoteStrEx(var S: String);
{}
function  StrCenter(S: String; Width: xByte): String;
function  StrCenterCh(S: String; Ch: Char; Width: xByte): String;
{}
function  WordCount(S: String; Separators: tCharSet): xByte;
function  WordPos(S: String; Separators: tCharSet; Index: xByte): xByte;
function  WordExtract(S: String; Separators: tCharSet; Index: xByte): String;
procedure WordWrap(S: String; Ch: tCharSet; Len: xByte; StrProc: tStrProc);
{}
function  GetAllAfterChar(const S: String; C: tCharSet; Index: xByte): String;
function  GetAllAfterSpace(const S: String; Index: xByte): String;
function  GetAllBeforeChar(const S: String; C: tCharSet; Index: xByte): String;
function  GetAllBeforeSpace(const S: String; Index: xByte): String;
{}
procedure StrReplaceEx(var _Source: String; _What, _To : String);
function  StrReplace(_Source, _What, _To: String): String;
procedure StrReplaceCSEx(var _Source: String; _What, _To : String);
function  StrReplaceCS(_Source, _What, _To: String): String;
procedure ReplaceCharEx(var S: String; _What, _To: Char);
function  ReplaceChar(const S: String; _What, _To: Char): String;
{}
function  StrFilter(S: String; C: tCharSet) : String;
procedure StrFilterEx(var S: String; C: tCharSet);
function  StrFilterRemain(S: String; C: tCharSet) : String;
procedure StrFilterRemainEx(var S: String; C: tCharSet);
{}
function  StrFilledChar(Ch: Char; Len: xByte): String;
function  StrTrunc(const S: String; Limit: xByte): String;
function  StrCompare(S, Mask: String): Boolean;
function  BlockPos(var Buffer; BufferSize: xWord; S: String): Integer;
function  EndPos(const What, Where: String): xByte;
{}
function  Str2Month(S: String): xWord;
function  Str2WeekDay(S: String): xWord;
function  Date2Str(Day, Month, Year: xWord): String;
function  Time2Str(Hour, Minute, Second: xWord): String;
function  __Date__     : String;
function  __DigitDate__: String;
function  __Time__     : String;
function  __DateTime__ : String;

{ *** Dos stuff *** }

{}
procedure FindClose(var SR: SearchRec);
function  DirExists(const Dir: String): Boolean;
function  fExists  (const FileName: String): Boolean;
function  CreateDir(const DirName: String): Boolean;
function  fGetAttr (const FName: String): Longint;
function  fGetStamp(const FName: String): Longint;
procedure fSetAttr (const FName: String; Attrs: Longint);
procedure fSetStamp(const FName: String; Stamp: Longint);
function  fCopy    (const Name1, Name2: String): Boolean;
function  fCopy2Dir(const Name1, Name2: String): Boolean;
function  fMove    (const Name1, Name2: String): Boolean;
function  fMove2Dir(const Name1, Name2: String): Boolean;
function  fGetSize (const Name: String): Longint;
function  fErase   (const Name: String): Boolean;
function  fRename  (const Name1, Name2: String): Boolean;
procedure ForceDir (Dir: String);
{}
function  fMaskCount(const Wildcard: String): LongInt;
function  fMaskSize (const Wildcard: String): LongInt;
function  fGetLinesCount(const FName: String): Longint;
function  fGetStrPos(const FName: String; S: String; CS: Boolean): Longint;
function  TextSeek    (var F: Text; Target: Longint): Boolean;
function  TextFileSize(var F: Text): Longint;
function  TextPos     (var F: Text): Longint;
{}
procedure StreamReadCh(var F: tStream; EndOfLine: tCharSet; var S: String);
procedure StreamRead(var F: tStream; var S: String);
procedure StreamWrite(var F: tStream; S: String);
function  StreamEOF(var F: tStream): Boolean;
{}
function  WithBackSlash(Path: String): String;
function  WithOutBackSlash(Path: String): String;
procedure AddBackSlash(var Path: String);
procedure RemoveBackSlash(var Path: String);
procedure FSplit(const Path: String; var Dir, Name, Ext: String);
function  Path2Dir(const Path: String): String;
function  Path2Name(const Path: String): String;
function  Path2Ext(const Path: String): String;
function  Path2NameExt(const Path: String): String;
function  ForceExt(const Name, Ext: String): String;
procedure ForceExtEx(var Name: String; Const Ext: String);
function  HasExt(const Name: String; var DotPos: Byte): Boolean;
function  LongFName2DosFName(const FName: String): String;
function  LongPath2DosPath(const Path: String): String;
function  GetExeDir: String;
function  GetTempFileName: String;
{}
function  ExtractDriveNumber(const Path: String): Byte;
{}
function  ftCreate(var F: Text; const FName: String): Boolean;
function  ftOpen  (var F: Text; const FName: String): Boolean;
function  ftAppend(var F: Text; const FName: String): Boolean;
function  fCreate (var F: File; const FName: String): Boolean;
function  fOpen   (var F: File; const FName: String): Boolean;
function  fAppend (var F: File; const FName: String): Boolean;
function  fFlag   (const FName: String): Boolean;
{[ Date/time stuff ]}
function  Y2ToDouble(Year: Longint): Longint;
function  DoubleToY2(Year: Longint): Longint;
{}
function  DateTimeIsToday(DT: DateTime): Boolean;
procedure _GetDate(var Day, Month, Year: xWord);
procedure _GetTime(var Hour, Minute, Second: xWord);
function  Timer: Longint;
procedure Wait(MS: Longint);
function  IsLeapYear(Year: xWord): Boolean;
function  DaysPast(Day, Month, Year: Longint): Longint;
{}
procedure UnpackUnixTime(Time: Longint;  var DT  : DateTime);
procedure PackUnixTime  (DT  : DateTime; var Time: Longint);
{}
procedure GetCurrentDateTime(var DT: DateTime);
function  GetCurrentUnixTime: Longint;
function  GetCurrentDosTime: Longint;
{}
function  WholeParamStr: String;
function  CalcBufSize: Longint;
{[10/04/00]}
procedure ClearIO;
procedure ResetIO;
function  CheckIO: Boolean;
{}

{}
{}
{}

implementation

{$IFNDEF VP}
type
  pTextBuffer = ^tTextBuffer;
  tTextBuffer = array[0..65520] of Byte;
  tText = record
    Handle: Word;
    Mode: Word;
    BufSize: Word;
    Priv: Word;
    BufPos: Word;
    BufEnd: Word;
    BufPtr: pTextBuffer;
    OpenProc: Pointer;
    InOutProc: Pointer;
    FlushProc: Pointer;
    CloseProc: Pointer;
    UserData: array[1..16] of Byte;
    Name: array[0..79] of Char;
    Buffer: array[0..127] of Char;
  end;

const
  FMClosed = $D7B0;
  FMInput  = $D7B1;
  FMOutput = $D7B2;
  FMInOut  = $D7B3;
{$ENDIF}

{ *** Strings stuff *** }

{[ tStCollection ]ͻ}
constructor tStCollection.Load(var S: tStream);
begin
  S.Reset;
  S.Seek(0);
  Count := 0;
  Limit := 0;
  Delta := 1;

  Items := nil;

  while not StreamEOF(S) do
    Insert(GetItem(S));
end;
{}
procedure tStCollection.FreeItem(Item: Pointer);
begin
  DisposeStr(Item);
end;
{}
function tStCollection.GetItem(var S: tStream): Pointer;
var
  St: String;
begin
  GetItem := nil;
  StreamRead(S, St);
  GetItem := NewStr(St);
end;
{}
procedure tStCollection.PutItem(var S: tStream; Item: Pointer);
begin
  StreamWrite(S, Concat(GetPString(Item), NL));
end;
{}
function tStCollection.IndexOf(Item: Pointer): xInt;
var
  i: xInt;
  p: pString absolute Item;
begin
  IndexOf := -1;
  for i := 0 to pred(Count) do
    if GetPString(Items^[i]) = GetPString(p) then
    begin
      IndexOf := i;
      Break;
    end;
end;
{}
function tStCollection.IndexOfNoCase(Item: Pointer): xInt;
var
  i: xInt;
  S: String;
begin
  IndexOfNoCase := -1;
  S := StrUpCase(GetPString(Item));

  for i := 0 to pred(Count) do
    if StrUpCase(GetPString(Items^[i])) = S then
    begin
      IndexOfNoCase := i;
      Break;
    end;
end;
{}
procedure tStCollection.Store(var S: tStream);
  procedure DoPutItem(P: Pointer); far;
  begin
    PutItem(S, P);
  end;
begin
  if @S = nil then Exit;

  ForEach(@DoPutItem);
end;
{ͼ}

{[ tStCollection ]ͻ}
procedure tStrings.FreeItem(Item: Pointer);
begin
  DisposeStr(Item);
end;
{ͼ}

{ͻ}
function N2Str(Num: Longint): String;
var
  S: String[10];
begin
  Str(Num, S);
  N2Str := S;
end;
{}
function N2FmtStr(Num: Longint): String;
var
  i: Integer;
  S: String[14];
begin
  Str(Num, S);

  if Length(S) = 0 then
  begin
    N2FmtStr := '';
    Exit;
  end;

  i := Length(S) - 2;

  while i > 1 do
  begin
    Insert(',', S, i);
    Dec(i, 3);
  end;

  if Str2Char(S, 1) = '-' then
    while Str2Char(S, 2) = ',' do Delete(S, 2, 1);

  N2FmtStr := S;
end;
{}
function Str2Number(const S: String): Boolean;
var
  x: Longint;
  C: xInt;
begin
  Val(S, x, C);
  Str2Number := (C = 0);
end;
{}
function Str2Int(const S: String): Integer;
var
  x: Integer;
  C: xInt;
begin
  if Length(S) = 0 then Str2Int := 0
  else begin Val(S, x, C); Str2Int := x end;
end;
{}
function Str2Word(const S: String): Word;
var
  x: Word;
  C: xInt;
begin
  if Length(S) = 0 then Str2Word := 0
  else begin Val(S, x, C); Str2Word := x end;
end;
{}
function Str2xWord(const S: String): xWord;
var
  x: xWord;
  C: xInt;
begin
  if Length(S) = 0 then Str2xWord := 0
  else begin Val(S, x, C); Str2xWord := x end;
end;
{}
function Str2Long(const S: String): LongInt;
var
  x: Longint;
  C: xInt;
begin
  if Length(S) = 0 then Str2Long := 0
  else begin Val(S, x, C); Str2Long := x end;
end;
{}
function Lead0(Num: Longint): String;
var
  S: String[2];
begin
  Str(Num, S);
  if Length(S) = 1 then S := Concat('0',S);
  Lead0 := S;
end;
{}
function HexB(B: Byte): String;
begin
 {$IfDef VP}
  SetLength(Result, 2);
 {$Else}
  HexB[0] := #2;
 {$EndIf}
  HexB[1] := Digits[B shr 4];
  HexB[2] := Digits[B and $F];
end;
{}
function HexW(W: Word): String;
begin
 {$IfDef VP}
  SetLength(Result, 4);
 {$Else}
  HexW[0] := #4;
 {$EndIf}
  HexW[1] := Digits[Hi(W) shr 4];
  HexW[2] := Digits[Hi(W) and $F];
  HexW[3] := Digits[Lo(W) shr 4];
  HexW[4] := Digits[Lo(W) and $F];
end;
{}
function HexL(L: Longint): String;
{$IFNDEF VP}
var
  S: String[8];
{$ENDIF}
begin
{$IFDEF VP}
  with LongRec(L) do
    HexL := HexW(Hi) + HexW(Lo);
{$ELSE}
  asm
    lea di,S
    db 66h
    mov dx,word ptr L
    mov cx,8
    mov ss:[di],cl
   @l2:
    inc di
    db  66h
    rol dx,4
    mov al,dl
    and al,0Fh
    cmp al,0Ah
    sbb al,69h
    das
    mov ss:[di],al
    loop @l2
  end;
  HexL := S;
{$ENDIF}
end;
{}
function HexPtr(P: Pointer): String;
var
  Z: record S,O: Word end absolute P;
begin
  HexPtr := HexW(Z.S) + ':' + HexW(Z.O);
end;
{}
function BinB(B: Byte): String;
var
  i: Byte;
begin
 {$IfDef VP}
  SetLength(Result, 8);
 {$Else}
  BinB[0] := #8;
 {$EndIf}
  for i := 0 to 7 do
    BinB[8-i] := Digits[Ord(B and (1 shl i) <> 0)];
end;
{}
function BinW(W: Word): String;
var
  i: Word;
begin
 {$IfDef VP}
  SetLength(Result, 16);
 {$Else}
  BinW[0] := #16;
 {$EndIf}
  for i := 0 to 15 do
    BinW[16-i] := Digits[Ord(W and (1 shl i) <> 0)];
end;
{}
function BinL(L: Longint): String;
var
  i: Longint;
begin
 {$IfDef VP}
  SetLength(Result, 32);
 {$Else}
  BinL[0] := #32;
 {$EndIf}
  for i := 0 to 31 do
    BinL[32-i] := Digits[Ord(L and Longint(1 shl i) <> 0)];
end;
{}
function Hex2N(Hex: String): Longint;
const
  LegalCh : tCharSet = ['$','H','h','x','X'];
var
  x    : Longint;
  Code : xInt;
begin
  Hex := LTrimCh(Hex, ['0']);
  Hex := TrimCh(Hex, LegalCh);
  Hex := Concat('$',Hex);

  Val(Hex, x, Code);
  Hex2N := x;
end;
{}
function Bin2N(Bin: String): Longint;
const
  BinCh : tCharSet = ['0','1'];
var
  r,
  k,
  i : Longint;
begin
  Bin := RTrimCh(Bin, ['d','D']);
  k := 31;

  if Length(Bin) > k then Bin := Copy(Bin, Length(Bin) - pred(k), k)
  else k := pred(Length(Bin));

  r := 0;
  for i := k downto 0 Do
  begin
    if not (Bin[succ(i)] in BinCh) then
    begin
      Bin2N := 0;
      Exit;
    end;
    if Bin[succ(i)] = '1' then Inc( r, Longint(1 shl (k - i)) );
  end;

  Bin2N := r;
end;
{}
function UpCase(C: Char): Char;
begin
  case C Of
    'a'..'z',''..'': UpCase := Char(Byte(C)-32);
    ''..''         : UpCase := Char(Byte(C)-80);
    ''              : UpCase := '';
    else               UpCase := C;
  end;
end;
{}
function LoCase(C: Char): Char;
begin
  case C of
    'A'..'Z',''..'': LoCase := Char(Byte(C)+32);
    ''..''         : LoCase := Char(Byte(C)+80);
    ''              : LoCase := '';
    else               LoCase := C;
  end;
end;
{}
function StrUpCase(const S: String): String;
var
  i: Byte;
begin
  for i := 1 to Length(S) do StrUpCase[i] := UpCase(S[i]);

 {$IfDef VP}
  SetLength(Result, Length(S));
 {$Else}
  StrUpCase[0] := S[0];
 {$EndIf}
end;
{}
function StrLoCase(const S: String): string;
var
  i: Byte;
begin
  for i := 1 to Length(S) do StrLoCase[i] := LoCase(S[i]);

 {$IfDef VP}
  SetLength(Result, Length(S));
 {$Else}
  StrLoCase[0] := S[0];
 {$EndIf}
end;
{}
procedure StrUpCaseEx(var S: String);
begin
  S := StrUpCase(S);
end;
{}
procedure StrLoCaseEx(var S: String);
begin
  S := StrLoCase(S);
end;
{}
function Str2Char(const S: String; Index: Byte): Char;
begin
  if Index > Length(S) then Str2Char := #0
  else Str2Char := S[Index];
end;
{}
function Char2Str(const C: Char): String;
begin
 {$IfDef VP}
  SetLength(Result, 1);
 {$Else}
  Char2Str[0] := #1;
 {$EndIf}
  Char2Str[1] := C;
end;
{}
function Str2pChar(const Source: String): Pointer;
var
  p: Pointer;
begin
  StrPCopy(p, Source);
  Str2pChar := p;
end;
{}
function StrPNew(const S: String): pChar;
var
  Len: xWord;
  p: pChar;
begin
  StrPNew := nil;

  if (Length(S) <> 0) then
  begin
    Len := Length(S);
    GetMem(p, Len + 1);
    Move(S[1], p^, Len);
    p[Len] := #0;
    StrPNew := p;
  end;
end;
{}
function pChar2Str(p: Pointer): String;
var
  Len: xWord;
  S: String;
begin
  pChar2Str := '';
  if p = nil then Exit;

  Len := StrLen(p);

  if Len > MaxStringSize then Len := MaxStringSize;

  Move(p^, S[1], Len);
  SetLength(S, Len);

  pChar2Str := S;
end;
{}
function GetPString(p: Pointer): String;
var
  S: pString absolute p;
begin
  if p <> nil then GetPString := S^
  else GetPString := '';
end;
{}
function Asciiz2Str(var Source): String;
var
  A: array[1..1] of Char absolute Source;
  i: xWord;
begin
  i := 1;

  repeat
    if A[i] = ZR then Break;
    inc(i);
  until i >= MaxStringSize;

  Asciiz2Str := Buf2Str(Source, i);
end;
{}
function Buf2Str(var Source; Size: xWord): String;
{$IfNDef VP}
var
  Result: String;
{$EndIf}
begin
  if Size > MaxStringSize then Size := MaxStringSize;

  Move(Source, Result[1], Size);
  SetLength(Result, Size);

 {$IfNDef VP}
  Buf2Str := Result;
 {$EndIf}
end;
{}
function LTrimCh(S: String; C: tCharSet): String;
{&IfOpt H-}
var
  SLen: Byte absolute S;
{&EndIf}
begin
  while (S[1] in C)and
        ({$IfDef VPH}Length(S){$Else}SLen{$EndIf} <> 0) do Delete(S, 1, 1);
  LTrimCh := S;
end;
{}
function RTrimCh(S: String; C: tCharSet): String;
{&IfOpt H-}
var
  SLen: Byte absolute S;
{&EndIf}
begin
  while (S[{$IfDef VPH}Length(S){$Else}SLen{$EndIf}] in C)and
        ({$IfDef VPH}Length(S){$Else}SLen{$EndIf} <> 0)
  do {$IfDef VPH} Delete(S, Length(S), 1) {$Else} Dec(SLen) {$EndIf};

  RTrimCh := S;
end;
{}
function TrimCh(S: String; C: tCharSet): String;
begin
  S := LTrimCh(S, C);
  S := RTrimCh(S, C);

  TrimCh := S;
end;
{}
function LTrim(S: String): String;
begin
  LTrim := LTrimCh(S, SpaceCh);
end;
{}
function RTrim(S: String): String;
begin
  RTrim := RTrimCh(S, SpaceCh);
end;
{}
function Trim(S: String): String;
begin
  Trim := TrimCh(S, SpaceCh);
end;
{}
procedure LTrimEx(var S: String);
begin
  S := LTrimCh(S, SpaceCh);
end;
{}
procedure RTrimEx(var S: String);
begin
  S := RTrimCh(S, SpaceCh);
end;
{}
procedure TrimEx(var S: String);
begin
  S := TrimCh(S, SpaceCh);
end;
{}
function _Trim(S: String): String;
begin
   _Trim := TrimCh(S, [#0..#32,#255]);
end;
{}
procedure _TrimEx(var S: String);
begin
  S := _Trim(S);
end;
{}
function LPadCh(S: String; C: Char; Len: xByte): String;
var
  St  : String;
 {&IfOpt H-}
  SLen: Byte absolute S;
 {&EndIf}
begin
  if Len > MaxStringSize then Len := MaxStringSize;

  if {$IfDef VPH} Length(S) {$Else} SLen {$EndIf} >= Len then LPadCh := S
  else
    begin
      SetLength(St, Len);
      Move(S[1], St[Succ(Word(Len)) - {$IfDef VPH}Length(S){$Else}SLen{$EndIf}],
                 {$IfDef VPH}Length(S){$Else}SLen{$EndIf});
      FillChar(St[1], Len - {$IfDef VPH}Length(S){$Else}SLen{$EndIf}, C);
      LPadCh := St;
    end;
end;
{}
function RPadCh(S: String; C: Char; Len: xByte): String;
var
  St  : String;
 {&IfOpt H-}
  SLen: Byte absolute S;
 {&EndIf}
begin
  if Len > MaxStringSize then Len := MaxStringSize;

  if {$IfDef VPH} Length(S) {$Else} SLen {$EndIf} >= Len then RPadCh := S
  else
    begin
      SetLength(St, Len);
      Move(S[1], St[1], {$IfDef VPH}Length(S){$Else}SLen{$EndIf});

      if {$IfDef VPH}Length(S){$Else}SLen{$EndIf} < MaxStringSize then
        FillChar(St[Succ({$IfDef VPH}Length(S){$Else}SLen{$EndIf})],
                 Len - {$IfDef VPH}Length(S){$Else}SLen{$EndIf}, C);
      RPadCh := St;
    end;
end;
{}
function LPad(S: String; Len: xByte): String;
begin
  LPad := LPadCh(S, ' ', Len);
end;
{}
function RPad(S: String; Len: xByte): String;
begin
  RPad := RPadCh(S, ' ', Len);
end;
{}
function QuoteStr(S: String): String;
begin
  if Length(S) = 0 then begin QuoteStr := '""'; Exit end;
  if Str2Char(S, 1)         <> '"' then S := '"'+S;
  if Str2Char(S, Length(S)) <> '"' then S := S+'"';

  QuoteStr := S;
end;
{}
function UnQuoteStr(S: String): String;
begin
  if (Str2Char(S, 1) = '"')and(Str2Char(S, Length(S)) = '"') then
  begin
    if Str2Char(S, 1) = '"' then Delete(S, 1, 1);
    if Str2Char(S, Length(S)) = '"' then Delete(S, Length(S), 1);
  end;

  UnQuoteStr := S;
end;
{}
procedure QuoteStrEx(var S: String);
begin
  S := QuoteStr(S);
end;
{}
procedure UnQuoteStrEx(var S: String);
begin
  S := UnQuoteStr(S);
end;
{}
function StrCenter(S: String; Width: xByte): String;
begin
  StrCenter := StrCenterCh(S, ' ', Width);
end;
{}
function StrCenterCh(S: String; Ch: Char; Width: xByte): String;
var
  St  : String;
 {&IfOpt H-}
  SLen: Byte absolute S;
 {&EndIf}
begin
  if {$IfDef VPH}Length(S){$Else}SLen{$EndIf} >= Width then StrCenterCh := S
  else {&IfOpt H-} if SLen < MaxStringSize then {&EndIf}
       begin
         SetLength(St, Width);
         FillChar(St[1], Width, Ch);
         Move(S[1], St[Succ((Width-{$IfDef VPH}Length(S){$Else}SLen{$EndIf}) shr 1)],
              {$IfDef VPH} Length(S) {$Else} SLen {$EndIf});
         StrCenterCh := St;
       end;
end;
{}
function WordCount(S: String; Separators: tCharSet): xByte;
var
  Count: xByte;
  i: xWord;
 {&IfOpt H-}
  SLen: Byte absolute S;
 {&EndIf}
begin
  Count := 0;
  i := 1;

  while i <= {$IfDef VPH}Length(S){$Else}SLen{$EndIf} do
  begin
    while (i <= {$IfDef VPH}Length(S){$Else}SLen{$EndIf})and
          (S[i] in Separators) do Inc(i);

    if i <= {$IfDef VPH}Length(S){$Else}SLen{$EndIf} then Inc(Count);

    while (i <= {$IfDef VPH}Length(S){$Else}SLen{$EndIf})and
       not(S[i] in Separators) do Inc(i);
  end;

  WordCount := Count;
end;
{}
function WordPos(S: String; Separators: tCharSet; Index: xByte): xByte;
var
  Count: xByte;
  i: xWord;
 {&IfOpt H-}
  SLen: Byte absolute S;
 {&EndIf}
begin
  Count := 0;
  i     := 1;
  WordPos := 0;

  while (i <= {$IfDef VPH}Length(S){$Else}SLen{$EndIf})and(Count <> Index) do
  begin
    while (i <= {$IfDef VPH}Length(S){$Else}SLen{$EndIf})and
          (S[i] in Separators) do Inc(i);

    if i <= {$IfDef VPH}Length(S){$Else}SLen{$EndIf} then Inc(Count);

    if Count <> Index then
      while (i <= {$IfDef VPH}Length(S){$Else}SLen{$EndIf})and
         not(S[i] in Separators) do Inc(i)
    else WordPos := i;
  end;
end;
{}
function WordExtract(S: String; Separators: tCharSet; Index: xByte): String;
var
  i    : xWord;
  Len  : xByte;
 {&IfOpt H-}
  SLen: Byte absolute S;
 {&EndIf}
begin
  Len := 0;
  i := WordPos(S, Separators, Index);

  if i <> 0 then
    while (i <= {$IfDef VPH}Length(S){$Else}SLen{$EndIf})and
       not(S[i] in Separators) do
    begin
      inc(Len);
      {$IfDef VPH}
       Result := Concat(Result, S[i]);
      {$Else}
       WordExtract[Len] := S[i];
      {$EndIf}
      inc(i);
    end;

 {$IfDef VPH}
  SetLength(Result, Len)
 {$Else}
  WordExtract[0] := Char(Len);
 {$EndIf}
end;
{}
procedure WordWrap(S: String; Ch: tCharSet; Len: xByte; StrProc: tStrProc);
var
 {&IfOpt H-}
  SLen: Byte absolute S;
 {&EndIf}
  Last, i: xInt;
begin
  if ({$IfDef VPH}Length(S){$Else}SLen{$EndIf} <= Len) then
  begin
    StrProc(S);
    Exit;
  end;

  Last := 0;

  repeat
    inc(Last);
    while (S[Last] in Ch)and
          (Last < {$IfDef VPH}Length(S){$Else}SLen{$EndIf}) do Inc(Last);

    i := pred(Last) + Len;
    if i > {$IfDef VPH}Length(S){$Else}SLen{$EndIf} then
      i := {$IfDef VPH}Length(S){$Else}SLen{$EndIf};

    while not(S[i] in Ch)and(i > Last) do Dec(i);
    while (S[i] in Ch)and(i > Last) do Dec(i);

    if i = Last then Inc(i, Len);

    StrProc(Copy(S, Last, i - pred(Last)));

    Last := i;
  until {$IfDef VPH}Length(S){$Else}SLen{$EndIf} - Last <= Len;

  inc(Last);
  while (S[Last] in Ch)and(Last < {$IfDef VPH}Length(S){$Else}SLen{$EndIf}) do
    Inc(Last);
  StrProc(Copy(S, Last, {$IfDef VPH}Length(S){$Else}SLen{$EndIf} - pred(Last)));
end;
{}
function GetAllAfterChar(const S: String; C: tCharSet; Index: xByte): String;
var
  i, k: xByte;
  Out: String;
begin
  Out := '';
  k   := 0;

  for i := 1 to Length(S) do
    if k >= Index then Out := Out + S[i]
    else if (S[i] in C) then Inc(k);

  GetAllAfterChar := Out;
end;
{}
function GetAllAfterSpace(const S: String; Index: xByte): String;
begin
  GetAllAfterSpace := GetAllAfterChar(S, SpaceCh, Index);
end;
{}
function GetAllBeforeChar(const S: String; C: tCharSet; Index: xByte): String;
var
  i, l: xByte;
 {$IfNDef VP}
  Result: String;
 {$EndIf}
 {&IfOpt H-}
  SLen: Byte absolute S;
 {&EndIf}
begin
  l := 0;
  Result := '';

  for i := 1 to {$IfDef VPH}Length(S){$Else}SLen{$EndIf} do
    if l < Index then
      if (S[i] in C) then
      begin
        if succ(l) < Index then Result := Result + S[i];
        while (S[succ(i)] in C)and
              (i < {$IfDef VPH}Length(S){$Else}SLen{$EndIf}) do inc(i);
        inc(l);
      end
      else Result := Concat(Result, S[i])
    else Break;

 {$IfNDef VP}
  GetAllBeforeChar := Result;
 {$EndIf}
end;
{}
function GetAllBeforeSpace(const S: String; Index: xByte): String;
begin
  GetAllBeforeSpace := GetAllBeforeChar(S, SpaceCh, Index);
end;
{}
procedure StrReplaceEx(var _Source : String; _What, _To : String);
var
  i, j: Byte;
begin
  StrUpCaseEx(_What);
  i := Pos(_What, StrUpCase(_Source));
  j := 0;

  while i <> 0 do
  begin
    Delete(_Source, i, Length(_What));
    Insert(_To, _Source, i);

    j := i + Length(_To);
    i := Pos(_What, StrUpCase(Copy(_Source, j, MaxStringSize)));

    if i <> 0 then inc(i, Pred(j));
  end;
end;
{}
function StrReplace(_Source, _What, _To: String): String;
begin
  StrReplaceEx(_Source, _What, _To);
  StrReplace := _Source;
end;
{}
procedure StrReplaceCSEx(var _Source : String; _What, _To : String);
var
  i, j: Byte;
begin
  i := Pos(_What, _Source);
  j := 0;

  while i <> 0 do
  begin
    Delete(_Source, i, Length(_What));
    Insert(_To, _Source, i);

    j := i + Length(_To);
    i := Pos(_What, Copy(_Source, j, MaxStringSize));

    if i <> 0 then inc(i, Pred(j));
  end;
end;
{}
function StrReplaceCS(_Source, _What, _To: String): String;
begin
  StrReplaceCSEx(_Source, _What, _To);
  StrReplaceCS := _Source;
end;
{}
procedure ReplaceCharEx(var S: String; _What, _To: Char);
begin
  S := ReplaceChar(S, _What, _To);
end;
{}
function ReplaceChar(const S: String; _What, _To: Char): String;
var
  i: Integer;
begin
  for i := 1 to Length(S) do
    if S[i] = _What then ReplaceChar[i] := _To
    else ReplaceChar[i] := S[i];
 {$IfDef VP}
  SetLength(Result, Length(S));
 {$Else}
  ReplaceChar[0] := S[0];
 {$EndIf}
end;
{}
function StrFilter(S: String; C: tCharSet) : String;
var
  i, Len: Word;
begin
  Len := 0;
  for i := 1 to Length(S) do
   if not(S[i] in C) then
   begin
     Inc(Len);
     StrFilter[Len] := S[i];
   end;

 {$IfDef VP}
  SetLength(Result, Len);
 {$Else}
  StrFilter[0] := Char(Len);
 {$EndIf}
end;
{}
procedure StrFilterEx(var S: String; C: tCharSet);
begin
  S := StrFilter(S, C);
end;
{}
function StrFilterRemain(S: String; C: tCharSet) : String;
var
  i, Len: Word;
begin
  Len := 0;
  for i := 1 to Length(S) do
   if S[i] in C then
   begin
     Inc(Len);
     StrFilterRemain[Len] := S[i];
   end;

 {$IfDef VP}
  SetLength(Result, Len);
 {$Else}
  StrFilterRemain[0] := Char(Len);
 {$EndIf}
end;
{}
procedure StrFilterRemainEx(var S: String; C: tCharSet);
begin
  S := StrFilterRemain(S, C);
end;
{}
function StrFilledChar(Ch: Char; Len: xByte): String;
{$IfNDef VP}
var
  S: String;
{$EndIf}
begin
 {$IfNDef VP}
  FillChar(S[1], Len, Ch);
  SetLength(S, Len);
  StrFilledChar := S;
 {$Else}
  FillChar(Result[1], Len, Ch);
  SetLength(Result, Len);
 {$EndIf}
end;
{}
function StrTrunc(const S: String; Limit: xByte): String;
begin
  StrTrunc := S;

  if Length(S) > Limit then
   {$IfDef VirtualPascal}
    SetLength(Result, Limit);
   {$Else}
    StrTrunc[0] := Char(Limit);
   {$EndIf}
end;
{}
{ Copied from unit Wizard (c) by sergey korowkin and little modified }
const
  ItsFirst : Integer = 0;

function StrCompare(S, Mask: String): Boolean;
var
  i,
  j   : Integer;
  Ok  : Boolean;
  St,
  Msk : String;
begin
  if (Pos('?', Mask) = 0)and(Pos('*', Mask) = 0) then
  begin
    StrCompare := (S = Mask);
    Exit;
  end;
  Inc(ItsFirst);
  i := 1;
  if ItsFirst = 1 then
  begin
    while True do
    begin
      j := Length(Mask);

      while i < Length(Mask) Do
      begin
        if (Mask[i] = '?')and(Mask[Succ(i)] = '*') then Delete(Mask, i, 1);
        if (Mask[i] = '*')and(Mask[Succ(i)] = '?')and(I < Length(Mask)) then
          Delete(Mask, Succ(i), 1);
        if (Mask[i] = '*')and(Mask[Succ(i)] = '*')and(I < Length(Mask)) then
          Delete(Mask, i, 1);
        Inc(i);
      end;

      if j = Length(Mask) then Break;

      i := 1;
    end;
  end;

  Ok := True;
  i := 1;
  j := 1;

  while True do
  begin
    case Mask[i] of
    '*': begin
           Msk := Copy(Mask, Succ(i), Length(Mask)-Pred(i));
           St  := Copy(S, j, Length(S)-Pred(j));
           while (St <> '')and(not StrCompare(St, Msk)) do Delete(St, 1, 1);
           if (St = '')and(Msk <> '') then Ok := False
           else j := Pos(St, S);
         end;
    '?': begin
           if (i = Length(Mask))and(j < Length(S)) then Ok := False;
           if j > Length(S) then Ok := False;
           Inc(j);
         end;
    else if Mask[i] <> S[j] then Ok := False
         else Inc(j);
    end; {Case}

    if Pred(j) > Length(S) then Ok := False;
    if not Ok then Break;
    Inc(i);
    if i > Length(Mask) then Break;
  end;

  StrCompare := Ok;
  Dec(ItsFirst);
end;
{ End of: Copied from unit Wizard (c) by sergey korowkin }
{}
function BlockPos(var Buffer; BufferSize: xWord; S: String): Integer;
{$IfDef VP}
var
  Buf: array[1..1]of Char absolute Buffer;
  i: Word;
begin
  BlockPos := 0;
  for i := 1 to (BufferSize - pred(Length(S))) do
    if Buf2Str(Buf[i], Length(S)) = S then
    begin BlockPos := i; Break; end;
end;
{$Else}
{ (c) unknown, 1976 }
begin
  inline($1E/$16/$1F/$C4/$BE/>Buffer/$89/$FB/$8B/$8E/>BufferSize/
         $8D/$B6/>S+2/$8A/$86/>S+1/$8A/$96/>S/$84/$D2/
         $74/$23/$FE/$CA/$30/$F6/$29/$D1/$76/$1B/$FC/
         $F2/$AE/$75/$16/$85/$D2/$74/$0C/$51/$57/$56/
         $89/$D1/$F3/$A6/$5E/$5F/$59/$75/$EC/$89/$F8/
         $29/$D8/$EB/$02/$31/$C0/$89/$46/$FE/$1F)
end;
{ End of: (c) unknown, 1976 }
{$EndIf}
{}
function EndPos(const What, Where: String): xByte;
var
  i: xByte;
begin
  EndPos := 0;

  for i := (Length(Where) - Length(What) + 1) downto 1 do
    if Copy(Where, i, Length(What)) = What then
    begin
      EndPos := i;
      Exit;
    end;
end;
{}
function Str2Month(S: String): xWord;
var
  Mon: xWord;
  c: xInt;
begin
  Str2Month := $FF;

  Val(S, Mon, c);
  if not Mon in [1..12] then Exit;

  if (c = 0)and(Mon in [1..12]) then
  begin
    Str2Month := Mon;
    Exit;
  end;

  StrUpCaseEx(S);

  for Mon := 1 to 12 do
    if (S = StrUpCase(Months[Mon]))or((S = StrUpCase(FullMonths[Mon]))) then
    begin
      Str2Month := Mon;
      Exit;
    end;
end;
{}
function Str2WeekDay(S: String): xWord;
var
  WDay: xWord;
  c: xInt;
begin
  Str2WeekDay := $FF;

  Val(S, WDay, c);
  if not WDay in [0..6] then Exit;

  if (c = 0)and(WDay in [0..6]) then
  begin
    Str2WeekDay := WDay;
    Exit;
  end;

  StrUpCaseEx(S);

  for WDay := 0 to 6 do
    if (S = StrUpCase(WDays[WDay]))or((S = StrUpCase(FullWDays[WDay]))) then
    begin
      Str2WeekDay := WDay;
      Exit;
    end;
end;
{}
function Date2Str(Day, Month, Year: xWord): String;
{$IfNDef VP}
var
  Result: String;
{$EndIf}
begin
  Result := Lead0(Day) + ' ';
  if Month in [1..12] then Result := Result + Months[Month] + ' '
  else Result := Result + '??? ';
  Result := Result + Lead0(Y2ToDouble(Year));
 {$IfNDef VP}
  Date2Str := Result;
 {$EndIf}
end;
{}
function Time2Str(Hour, Minute, Second: xWord): String;
begin
  Time2Str := Lead0(Hour)+':'+Lead0(Minute)+':'+Lead0(Second);
end;
{}
function __Date__: String;
var
  Year, Month, Day: xWord;
begin
  _GetDate(Day, Month, Year);
  __Date__ := Lead0(Day)+' '+Months[Month]+' '+Lead0(Y2ToDouble(Year));
end;
{}
function __DigitDate__: String;
var
  Year, Month, Day: xWord;
begin
  _GetDate(Day, Month, Year);
  __DigitDate__ := Lead0(Day)+'.'+Lead0(Month)+'.'+Lead0(Y2ToDouble(Year));
end;
{}
function __Time__: String;
var
  Hour, Min, Sec: xWord;
begin
  _GetTime(Hour, Min, Sec);
  __Time__ := Lead0(Hour)+':'+Lead0(Min)+':'+Lead0(Sec);
end;
{}
function __DateTime__: String;
var
  Year, Month, Day, Hour, Min, Sec: xWord;
begin
   _GetDate(Day, Month, Year);
   _GetTime(Hour, Min, Sec);
   __DateTime__ := Lead0(Day) +' '+Months[Month]+' '+Lead0(Y2ToDouble(Year))+
                   ' '+Lead0(Hour)+':'+Lead0(Min)+':'+Lead0(Sec);
end;
{ͼ}

{ *** Dos stuff *** }
{ͻ}
procedure FindClose(var SR: SearchRec);
begin
  {$IfDef VP}
   Dos.FindClose(SR);
  {$EndIf}
end;
{}
function DirExists(const Dir: String): Boolean;
var
  SR: SearchRec;
begin
  Dos.FindFirst(WithBackSlash(Dir)+'*.*', AnyFile, SR);
  DirExists := (DosError = 0);
  FindClose(SR);
end;
{}
function fExists(const FileName: String): Boolean;
var
  A: xWord;
  F: File;
begin
  Assign(F, FileName);
  GetFAttr(F, A);
  fExists := (DosError in [0,5])and(A and (Directory or VolumeId) = 0);
end;
{}
function CreateDir(const DirName: String): Boolean;
begin
  ResetIO;

  MkDir(WithOutBackSlash(FExpand(DirName)));

  CreateDir := (CheckIO)and(Length(DirName) <> 0);

  ResetIO;
end;
{}
function fGetAttr(const FName: String): Longint;
var
  F: File;
  A: xWord;
begin
  ResetIO;

  Assign(F, FName);
  GetFAttr(F, A);

  if not CheckIO then
    fGetAttr := -1
  else
    fGetAttr := A;
end;
{}
function fGetStamp(const FName: String): Longint;
var
  SR: SearchRec;
begin
  Dos.FindFirst(FName, AnyFile, SR);

  if DosError <> 0 then fGetStamp := -1
                   else fGetStamp := SR.Time;

  FindClose(SR);
end;
{}
procedure fSetAttr(const FName: String; Attrs: Longint);
var
  F: File;
begin
  ResetIO;

  Assign(F, FName);
  SetFAttr(F, Attrs);

  ResetIO;
end;
{}
procedure fSetStamp(const FName: String; Stamp: Longint);
var
  F: File;
begin
  ResetIO;

  Assign(F, FName);
  Reset(F);

  if not CheckIO then Exit;

  SetFTime(F, Stamp);
  Close(F);

  ResetIO;
end;
{}
function fCopy(const Name1, Name2: String): Boolean;
var
  F1, F2    : File;
  A         : xWord;
  T         : Longint;
  P         : Pointer;
  NumRead,
  NumWritten: xWord;
  TheBufSize: Longint;
begin
  fCopy := False;

  if StrUpCase(Name1) = StrUpCase(Name2) then Exit;

  TheBufSize := CalcBufSize;

  GetMem(P, TheBufSize);

  GetFAttr(F1, A);
  SetFAttr(F1, Archive);
  GetFTime(F1, T);

  if not fOpen(F1, Name1)   then begin FreeMem(P, TheBufSize); Exit end;
  if not fCreate(F2, Name2) then begin FreeMem(P, TheBufSize); Exit end;

  repeat
    BlockRead(F1, P^, TheBufSize, NumRead);
    BlockWrite(F2, P^, NumRead, NumWritten);

    if NumRead <> NumWritten then begin FreeMem(P, TheBufSize); Exit end;
  until NumRead = 0;

  Close(F2);
  Close(F1);

  SetFAttr(F1, A);
  SetFAttr(F2, A);
  SetFTime(F2, T);

  FreeMem(P, TheBufSize);

  fCopy := True;
end;
{}
function fCopy2Dir(const Name1, Name2: String): Boolean;
begin
  fCopy2Dir := fCopy(Name1, WithBackSlash(Name2)+Path2NameExt(Name1))
end;
{}
function fMove(const Name1, Name2: String): Boolean;
var
  F: File;
begin
  fMove := False;

  if ExtractDriveNumber(Name1) = ExtractDriveNumber(Name2) then
    fMove := fRename(Name1, Name2)
  else begin
         if not fCopy(Name1, Name2) then Exit;
         if not fErase(Name1) then Exit;
         fMove := True;
       end;
end;
{}
function fMove2Dir(const Name1, Name2: String): Boolean;
begin
  fMove2Dir := fMove(Name1, WithBackSlash(Name2)+Path2NameExt(Name1))
end;
{}
function fGetSize(const Name: string): Longint;
var
  SR: SearchRec;
begin
  Dos.FindFirst(Name, AnyFile, SR);

  if DosError = 0 then fGetSize := SR.Size
                  else fGetSize := -1;

  FindClose(SR);
end;
{}
function fErase(const Name : String): Boolean;
var
  F: File;
begin
  ResetIO;

  Assign(F, Name);
  Erase(F);

  fErase := CheckIO;

  ResetIO;
end;
{}
function fMaskCount(const Wildcard: String): Longint;
var
  SR   : SearchRec;
  Count: Longint;
begin
  Count := 0;
  Dos.FindFirst(Wildcard, AnyFile, SR);

  while DosError = 0 do
  begin
    inc(Count);
    Dos.FindNext(SR);
  end;

  fMaskCount := Count;
  FindClose(SR);
end;
{}
function fMaskSize(const Wildcard: String): Longint;
var
  SR  : SearchRec;
  Size: Longint;
begin
  Size := 0;
  Dos.FindFirst(Wildcard, AnyFile, SR);

  while DosError = 0 do
  begin
    Inc(Size, SR.Size);
    Dos.FindNext(SR);
  end;

  fMaskSize := Size;
  FindClose(SR);
end;
{}
function fRename(const Name1, Name2 : String): Boolean;
var
  F: File;
begin
  ResetIO;

  Assign(F, Name1);
  Rename(F, Name2);

  fRename := CheckIO;

  ResetIO;
end;
{}
procedure ForceDir(Dir: String);
var
  i: xInt;
begin
  AddBackSlash(Dir);

  if not DirExists(Dir) then
    for i := Pos(':', Dir) to Length(Dir) do
      if Dir[i] = '\' then
        MkDir(Copy(Dir, 1, pred(i)));
end;
{}
function fGetLinesCount(const FName: String): longint;
var
  F: Text;
  i: Longint;
begin
  ResetIO;

  Assign(F, FName);
  Reset(F);

  if not CheckIO then begin fGetLinesCount := -1; Exit end;

  i := 0;
  while not EOF(F) do begin Readln(f); Inc(i) end;

  Close(F);

  fGetLinesCount := i;
end;
{}
function fGetStrPos(const FName: String; S: String; CS: Boolean): Longint;
var
  ok : Boolean;
  st : String;
  l  : Longint;
  F  : Text;
begin
  fGetStrPos := -1;
  Ok := False;
  l  := 0;

  ResetIO;

  Assign(F, FName);
  Reset(F);

  if not CheckIO then Exit;

  if not CS then StrUpCaseEx(S);

  while (not EOF(F))or(Ok)do
  begin
    Readln(F, St);
    if not CS then StrUpCaseEx(St);
    if Pos(S, St) <> 0 then begin Ok := True; Inc(l, Pos(S, St)); Break end
    else Inc(l, Length(St) + 2);
  end;

  if Ok then fGetStrPos := l;
end;
{}
{$IFNDEF VP}
{ The following part of code has been cut from
  Turbo Professional 5.21 (c) by TurboPower Software, 1987, 1992. }
function TextSeek(var F: Text; Target: LongInt): Boolean;
var
  T: LongRec absolute Target;
  Pos: LongInt;
  Regs: Dos.Registers;
begin
  TextSeek := False;
  with Regs, TText(F) do
  begin
    if Mode <> FMInput then Exit;

    AX := $4201;
    BX := Handle;
    CX := 0;
    DX := 0;
    MsDos(Regs);

    if Odd(Flags) then Exit;

    LongRec(Pos).Hi := DX;
    LongRec(Pos).Lo := AX;
    Dec(Pos, BufEnd);
    Pos := Target - Pos;
    if (Pos >= 0)and(Pos < BufEnd) then BufPos := Pos
    else begin
           AX := $4200;
           BX := Handle;
           CX := T.Hi;
           DX := T.Lo;
           MsDos(Regs);

           if Odd(Flags) then Exit;
           BufEnd := 0;
           BufPos := 0;
         end;
  end;
   TextSeek := True;
end;
{}
function TextFileSize(var F: Text): LongInt;
var
  OldHi, OldLow: Integer;
  Regs: Dos.Registers;
begin
  with Regs, TText(F) do
  begin
    if Mode = FMClosed then begin TextFileSize := -1; Exit end;

    AX := $4201;
    BX := Handle;
    CX := 0;
    DX := 0;
    MsDos(Regs);

    if Odd(Flags) then begin TextFileSize := -1; Exit end;

    OldHi  := DX;
    OldLow := AX;
    AX := $4202;
    BX := Handle;
    CX := 0;
    DX := 0;
    MsDos(Regs);

    if Odd(Flags) then begin TextFileSize := -1; Exit end;

    TextFileSize := LongInt(DX) shl 16 + AX;
    AX := $4200;
    BX := Handle;
    CX := OldHi;
    DX := OldLow;
    MsDos(Regs);

    if Odd(Flags) then TextFileSize := -1;
  end;
end;
{}
function TextPos(var F: Text): LongInt;
var
  Position: LongInt;
  Regs: Dos.Registers;
begin
  with Regs, TText(F) do
  begin
    if Mode = FMClosed then begin TextPos := -1; Exit end;

    AX := $4201;
    BX := Handle;
    CX := 0;
    DX := 0;
    MsDos(Regs);

    if Odd(Flags) then begin TextPos := -1; Exit end;

    LongRec(Position).Hi := DX;
    LongRec(Position).Lo := AX;

    if Mode = FMOutput then Inc(Position, BufPos)
    else if BufEnd <> 0 then
          Dec(Position, BufEnd - BufPos);

    TextPos := Position;
  end;
end;
{$Else}
{}
function TextSeek(var F: Text; Target: LongInt): Boolean;
var
  P: LongInt;
  T: TextRec absolute F;
begin
  TextSeek := True;

  SysFileSeek(T.Handle, 0, 1, P);

  Dec(P, T.BufEnd);

  P := Target - P;

  if (P >= 0)and(P < T.BufEnd) then T.BufPos := P
  else begin
         SysFileSeek(T.Handle, Target, 0, P);

         T.BufEnd := 0;
         T.BufPos := 0;
       end;
end;
{}
function TextFileSize(var F: Text): LongInt;
var
  T: TextRec absolute F;
  P: Longint;
begin
  SysFileSeek(T.Handle, 0, 1, P);
  SysFileSeek(T.Handle, 0, 2, Result);
  SysFileSeek(T.Handle, P, 0, P);
end;
{}
function TextPos(var F: Text): LongInt;
var
  T: TextRec absolute F;
begin
  SysFileSeek(T.Handle, 0, 1, Result);

  if T.Mode = fmOutput then Inc(Result, T.BufPos)
  else if T.BufEnd <> 0 then Dec(Result, T.BufEnd - T.BufPos);
end;
{$ENDIF}
{}
procedure StreamReadCh(var F: tStream; EndOfLine: tCharSet; var S: String);
var
  Ch: Char;
begin
  if @F = nil then Exit;
  SetLength(S, 0);

  repeat
    F.Read(Ch, 1);
    if (F.Status = stOk) and not(Ch in EndOfLine) then S :=Concat(S, Ch);
  until ( (F.Status <> stOk)or(Ch in EndOfLine) );

  if F.Status = stOk then
    repeat
      F.Read(Ch, 1);
      if not(Ch in EndOfLine) then F.Seek(F.GetPos - 1);
    until not(Ch in EndOfLine)
  else
    begin
      F.Reset;
      F.Seek(F.GetSize);
    end;
end;
{}
procedure StreamRead(var F: tStream; var S: String);
var
  C, Ch: Char;
begin
  if @F = nil then Exit;
  SetLength(S, 0);

  repeat
    F.Read(C, 1);
    if (F.Status = stOk)and(C <> CR)and(C <> LF) then S := Concat(S, C);
  until ( (F.Status <> stOk)or(C = CR)or(C = LF) );

  if F.Status = stOk then
    begin
      F.Read(Ch, 1);
      if ((C = LF)and(Ch <> CR))or((C = CR)and(Ch <> LF)) then
        F.Seek(pred(F.GetPos));
    end
  else
    begin
      F.Reset;
      F.Seek(F.GetSize);
    end;
end;
{}
procedure StreamWrite(var F: tStream; S: String);
begin
  if @F = nil then Exit;
  F.Write(S[1], Length(S));
end;
{}
function StreamEOF(var F: tStream): Boolean;
begin
  if @F = nil then Exit;

  StreamEOF := (F.GetPos = F.GetSize);
end;
{}
function WithBackSlash(Path: String): String;
begin
  if Path[Length(Path)] <> '\' then Path := Path + '\';
  WithBackSlash := Path;
end;
{}
function WithOutBackSlash(Path: String): String;
begin
  if Path[Length(Path)] = '\' then
    {$IfDef VPH}Delete(Path, Length(Path), 1){$Else}Dec(Path[0]){$EndIf};
  WithOutBackSlash := Path;
end;
{}
procedure AddBackSlash(var Path: String);
begin
  Path := WithBackSlash(Path);
end;
{}
procedure RemoveBackSlash(var Path: String);
begin
  Path := WithOutBackSlash(Path);
end;
{}
procedure FSplit(const Path: String; var Dir, Name, Ext: String);
var
  i, NamePos, ExtPos: Integer;
begin
  NamePos := 0;
  ExtPos  := 256;

  for i := 1 to Length(Path) do
    case Path[i] of
      ':', '\': begin
                  NamePos := i;
                  ExtPos  := 256;
                end;
           '.': ExtPos := i;
    end;

  Dir  := Copy(Path, 1, NamePos);
  Name := Copy(Path, Succ(NamePos), Pred(ExtPos-NamePos));
  Ext  := Copy(Path, ExtPos, 255);
end;
{}
function Path2Dir(const Path: String): String;
var
  D, N, E: String;
begin
  Dp_Comn.FSplit(Path, D, N, E);
  Path2Dir := D;
end;
{}
function Path2Name(const Path: String): String;
var
  D, N, E: String;
begin
  Dp_Comn.FSplit(Path, D, N, E);
  Path2Name := N;
end;
{}
function Path2Ext(const Path: String): String;
var
  D, N, E: String;
begin
  Dp_Comn.FSplit(Path, D, N, E);
  Path2Ext := E;
end;
{}
function Path2NameExt(const Path: String): String;
var
  D, N, E: String;
begin
  Dp_Comn.FSplit(Path, D, N, E);
  Path2NameExt := N + E;
end;
{}
function ForceExt(const Name, Ext: String): String;
var
  DotPos: Byte;
begin
  if HasExt(Name, DotPos) then ForceExt := Copy(Name, 1, DotPos)+Ext
  else ForceExt := Name+'.'+Ext;
end;
{}
procedure ForceExtEx(var Name: String; Const Ext: String);
begin
  Name := ForceExt(Name, Ext);
end;
{}
function HasExt(const Name: String; var DotPos: Byte): Boolean;
var
  i: Byte;
begin
  DotPos := 0;
  for i := Length(Name) downto 1 Do
      if Name[i] = '.' then begin DotPos := i; Break end;
  HasExt := (DotPos > 0)and(Pos('\', Copy(Name, Succ(DotPos), 255)) = 0);
end;
{}
function LongFName2DosFName(const FName: String): String;
var
  S: String;
  i: Integer;
begin
  S := Path2Name(FName);
  i := 1;

  StrFilterEx(S, SpaceCh);

  if Length(S) > 8 then S := Copy(S, 1, 6) + '~1';
  LongFName2DosFName := S + Copy(Path2Ext(FName), 1, 4);
end;
{}
function LongPath2DosPath(const Path: String): String;
var
  i, j: Integer;
  S   : String;
  Out : String;
begin
  Out := '';
  for i := Length(Path) downto 1 do
      if Path[i] = '\' then
      begin
        j := i;
        while (Path[pred(i)] <> '\')and(i > 0) do Dec(i);
        S := Copy(Path, i, j-i);
        if Copy(S, Pred(Length(S)), 2) <> ':\' then
          S := LongFName2DosFName(S);
        Out := WithBackSlash(S) + Out;
      end
      else if i < 0 then Break;
  LongPath2DosPath := Out + LongFName2DosFName(Path2NameExt(Path));
end;
{}
function GetExeDir: String;
begin
  GetExeDir := Path2Dir(ParamStr(0));
end;
{}
function GetTempFileName: String;
  function GetMsgId: String;
  var
    Stamp: Longint;
    StampW: record
              L, H: Word
            end absolute Stamp;
    Year, Month, Day, WD, Hour, Min, Sec, Sec100: xWord;
    DT: DateTime;
  begin
    Dos.GetDate(Year, Month, Day, WD);
    Dos.GetTime(Hour, Min,   Sec, Sec100);

    Stamp := Longint(Year)*365*24*60*60;
    Inc(Stamp, Longint(Month)*30*24*60*60);
    Inc(Stamp, Longint(Day)*24*60*60);
    Inc(Stamp, Longint(Hour)*60*60);
    Inc(Stamp, Longint(Min)*60);
    Inc(Stamp, Longint(Sec));
    Stamp := (Stamp shl 7)or(Sec100 and $7F);
    Inc(Stamp, Random($FFFF));

    GetMsgId := LoDigits[Hi(StampW.H) shr  4] +
                LoDigits[Hi(StampW.H) and $F] +
                LoDigits[Lo(StampW.H) shr  4] +
                LoDigits[Lo(StampW.H) and $F] +
                LoDigits[Hi(StampW.L) shr  4] +
                LoDigits[Hi(StampW.L) and $F] +
                LoDigits[Lo(StampW.L) shr  4] +
                LoDigits[Lo(StampW.L) and $F];
  end;
var
  Path: String;
  Name: String[8];
  Ext: String[4];
begin
  Path := GetEnv('TEMP');
  Ext  := '.tmp';

  if Path = '' then Path := ExeDir;
  AddBackSlash(Path);

  repeat
    Name := GetMsgId;
  until not fExists(Path+Name+Ext);

  GetTempFileName := Path+Name+Ext;
end;
{}
function ExtractDriveNumber(const Path: String): Byte;
var
  Drive: Char;
 {&IfOpt H-}
  PathLen: Byte absolute Path;
 {&EndIf}
begin
  ExtractDriveNumber := 0;
  if {$IfDef VPH}Length(Path){$Else}PathLen{$EndIf} = 0 then Exit;

  Drive := System.UpCase(Path[1]);
  if ( ({$IfDef VPH}Length(Path){$Else}PathLen{$EndIf} = 1)or
       ( ({$IfDef VPH}Length(Path){$Else}PathLen{$EndIf} >= 2)and
         (Path[2] = ':') ) )and
     ( Drive in ['A'..'Z'] )
  then ExtractDriveNumber := Byte(Drive) - 64;
end;
{}
function ftCreate(var F: Text; const FName: String): Boolean;
begin
  ResetIO;

  Assign(F, FName);
  Rewrite(F);

  ftCreate := CheckIO;

  ResetIO;
end;
{}
function ftOpen(var F: Text; const FName: String): Boolean;
begin
  ResetIO;

  Assign(F, FName);
  Reset(F);

  ftOpen := CheckIO;

  ResetIO;
end;
{}
function ftAppend(var F: Text; const FName: String): Boolean;
begin
  ResetIO;

  Assign(F, FName);
  Append(F);

  ftAppend := CheckIO;

  ResetIO;
end;
{}
function fCreate(var F: File; const FName: String): Boolean;
begin
  ResetIO;

  Assign(F, FName);
  Rewrite(F, 1);

  fCreate := CheckIO;

  ResetIO;
end;
{}
function fOpen(var F: File; const FName: String): Boolean;
var
  OldMode: Byte;
begin
  ResetIO;

  OldMode  := FileMode;
  FileMode := 0;

  Assign(F, FName);
  Reset(F, 1);

  fOpen := CheckIO;

  FileMode := OldMode;

  ResetIO;
end;
{}
function fAppend(var F: File; const FName: String): Boolean;
var
  OldMode : Byte;
begin
  fAppend := False;
  ResetIO;

  OldMode  := FileMode;
  FileMode := 2;

  Assign(F, FName);
  Reset(F, 1);

  if not CheckIO then Exit;

  Seek(F, FileSize(F));

  if not CheckIO then Exit;

  fAppend := True;
  FileMode := OldMode;

  ResetIO;
end;
{}
function fFlag(const FName: String): Boolean;
var
  F: File;
begin
  ResetIO;

  Assign(F, FName);
  Rewrite(F);

  fFlag := CheckIO;

  Close(F);

  ResetIO;
end;
{}
function Y2ToDouble(Year: Longint): Longint;
begin
  if Year >= 2000 then Y2ToDouble := Year - 2000
  else Y2ToDouble := Year - 1900;
end;
{}
function DoubleToY2(Year: Longint): Longint;
begin
  if Year <= 70 then DoubleToY2 := Year + 2000
  else DoubleToY2 := Year + 1900;
end;
{}
function DateTimeIsToday(DT: DateTime): Boolean;
var
  Y, M, D: xWord;
begin
  _GetDate(D, M, Y);
  DateTimeIsToday := (DT.Year = Y)and(DT.Month = M)and(DT.Day = D);
end;
{}
{$IFDEF DOS}
procedure _GetDate(var Day, Month, Year: xWord); assembler;
asm
  mov   ah,2Ah
  int   21h
  xor   ah,ah
  mov   al,dl
  les   di,day
  stosw
  mov   al,dh
  les   di,month
  stosw
  xchg  ax,cx
  les   di,year
  stosw
end;
{$ELSE}
procedure _GetDate(var Day, Month, Year: xWord);
var
  WeekDay: xWord;
begin
  Dos.GetDate(Year, Month, Day, WeekDay);
end;
{$ENDIF}
{}
{$IFDEF DOS}
procedure _GetTime(var Hour, Minute, Second: Word); assembler;
asm
  mov   ah,2Ch
  int   21h
  xor   ah,ah
  mov   al,dh
  les   di,Second
  stosw
  mov   al,cl
  les   di,Minute
  stosw
  mov   al,ch
  les   di,Hour
  stosw
end;
{$ELSE}
procedure _GetTime(var Hour, Minute, Second: xWord);
var
  Sec100: xWord;
begin
  Dos.GetTime(Hour, Minute, Second, Sec100);
end;
{$ENDIF}
{}
function Timer: Longint;
{$IFDEF VP}
begin
  Timer := SysSysMsCount;
end;
{$ELSE}
assembler;
  asm
   push    ds              { save caller's data segment }
   mov     ds, seg0040     {  access ticker counter }
   mov     bx, 6ch         { offset of ticker counter in segm.}
   mov     dx, 43h         { timer chip control port }
   mov     al, 4           { freeze timer 0 }
   pushf                   { save caller's int flag setting }
   cli                     { make reading counter an atomic operation}
   mov     di, ds:[bx]     { read bios ticker counter }
   mov     cx, ds:[bx+2]
   sti                     { enable update of ticker counter }
   out     dx, al          { latch timer 0 }
   cli                     { make reading counter an atomic operation}
   mov     si, ds:[bx]     { read bios ticker counter }
   mov     bx, ds:[bx+2]
   in      al, 40h         { read latched timer 0 lo-byte }
   mov     ah, al          { save lo-byte }
   in      al, 40h         { read latched timer 0 hi-byte }
   popf                    { restore caller's int flag }
   xchg    al, ah          { correct order of hi and lo }
   cmp     di, si          { ticker counter updated ? }
   je      @no_update      { no }
   or      ax, ax          { update before timer freeze ? }
   jns     @no_update      { no }
   mov     di, si          { use second }
   mov     cx, bx          {  ticker counter }
@no_update:  not     ax              { counter counts down }
   mov     bx, 36edh       { load multiplier }
   mul     bx              { w1 * m }
   mov     si, dx          { save w1 * m (hi) }
   mov     ax, bx          { get m }
   mul     di              { w2 * m }
   xchg    bx, ax          { ax = m, bx = w2 * m (lo) }
   mov     di, dx          { di = w2 * m (hi) }
   add     bx, si          { accumulate }
   adc     di, 0           {  result }
   xor     si, si          { load zero }
   mul     cx              { w3 * m }
   add     ax, di          { accumulate }
   adc     dx, si          {  result in dx:ax:bx }
   mov     dh, dl          { move result }
   mov     dl, ah          {  from dl:ax:bx }
   mov     ah, al          {   to }
   mov     al, bh          {    dx:ax:bh }
   mov     di, dx          { save result }
   mov     cx, ax          {  in di:cx }
   mov     ax, 25110       { calculate correction }
   mul     dx              {  factor }
   sub     cx, dx          { subtract correction }
   sbb     di, si          {  factor }
   xchg    ax, cx          { result back }
   mov     dx, di          {  to dx:ax }
   pop     ds              { restore caller's data segment }
  end;
{$ENDIF}
{}
{ * (q) by sergey korowkin [2:6033/27] * }
procedure Wait(MS: Longint);
{$IFDEF VP}
begin
  SysCtrlSleep(MS);
end;
{$ELSE}
var
  Anchor, Current: Longint;
begin
  Anchor := Timer + MS;

  repeat
    Current := Timer;
  until (Current >= Anchor);
end;
{$ENDIF}
{ * end of: (q) by sergey korowkin [2:6033/27] * }
{}
function IsLeapYear(Year: xWord): Boolean;
begin
  IsLeapYear := (Year mod 4 = 0)and(Year mod 100 <> 0)or(Year mod 400 = 0);
end;
{}
function DaysPast(Day, Month, Year: Longint): Longint;
const
  DaysPerYear = 365;
var
  i: Byte;
  D: Longint;
begin
  if Month > 12 then Month := 12;
  D := (Year - 1970) * DaysPerYear + (Year - 1969) div 4;

  for i := 1 to pred(Month) do
    inc(D, Days[IsLeapYear(Year), i]);

  inc(D, pred(Day));
  DaysPast := D;
end;
{}
{ * (c) Todd Fiske 1994-1996 * }
const
  days_per_month : array[0..11] of byte =
    ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );

  secs_per_min   =       60;
  secs_per_hour  =     3600;     { 60 * 60 }
  secs_per_day   =    86400;     { 60 * 60 * 24 }
  secs_per_year  = 31536000;     { 60 * 60 * 24 * 365 }
  secs_per_lyear = 31622400;     { 60 * 60 * 24 * 366 }

  days_per_year  = 365;
  days_per_lyear = 366;

  days_per_odd_dec  = 3652;
  days_per_even_dec = 3653;

  secs_per_odd_dec  = 315532800; { (secs_per_year * 10) + (secs_per_day * 2); }
  secs_per_even_dec = 315619200; { (secs_per_year * 10) + (secs_per_day * 3); }

  secs_to_1980      = 315532800; { secs_per_odd_dec }
  secs_to_1990      = 631152000; { secs_to_1980 + secs_per_even_dec; }
  secs_to_2000      = 946684800; { secs_to_1990 + secs_per_odd_dec; }

  secs_to_19960101  = 820454400;

{}
procedure UnpackUnixTime(Time: Longint; var DT: DateTime);
begin
  dt.year  := 0;    { 1970 }
  dt.month := 0;    { January }
  dt.day   := 0;    { First }

  dt.hour  := 0;    { midnight }
  dt.min   := 0;
  dt.sec   := 0;

  while (time >= secs_per_year) do
  begin
    if (((dt.year + 2) mod 4) = 0) then dec(time, secs_per_day);
    inc(dt.year);
    dec(time, secs_per_year);
  end;

  if (((dt.year + 2) mod 4) = 0) then inc(days_per_month[1]);

  while (time >= (days_per_month[dt.month] * secs_per_day)) do
  begin
    dec(time, days_per_month[dt.month] * secs_per_day);
    inc(dt.month);
  end;

  while (time >= secs_per_day) do
  begin
    dec(time, secs_per_day);
    inc(dt.day);
  end;

  while (time >= secs_per_hour) do
  begin
    dec(time, secs_per_hour);
    inc(dt.hour);
  end;

  while (time >= secs_per_min) do
  begin
    dec(time, secs_per_min);
    inc(dt.min);
  end;

  dt.sec := time;

  if days_per_month[1] = 29 then dec(days_per_month[1]);

  inc(dt.year, 1970);
  inc(dt.month);
  inc(dt.day);
end;
{}
procedure PackUnixTime(DT: DateTime; var Time: Longint);
var
  i              : word;
  days_this_year : word;
  num_leap_years : word;
begin
  dec(dt.year, 1970);
  dec(dt.month);
  dec(dt.day);

  time := dt.sec;

  inc(time, dt.min  * secs_per_min);
  inc(time, longint(dt.hour) * secs_per_hour);

  if (((dt.year + 2) mod 4) = 0) then inc(days_per_month[1]);

  days_this_year := dt.day;
  i := 0;
  while (i < dt.month) do
  begin
    inc(days_this_year, days_per_month[i]);
    inc(i);
  end;

  inc(time, days_this_year * secs_per_day);

  if days_per_month[1] = 29 then dec(days_per_month[1]);

  inc(time, dt.year * secs_per_year);

  num_leap_years := (dt.year + 2) div 4;
  if (((dt.year+2) mod 4) = 0) then dec(num_leap_years);

  inc(time, num_leap_years * secs_per_day);
end;
{ * end of: (c) Todd Fiske 1994-1996 * }
{}
procedure GetCurrentDateTime(var DT: DateTime);
begin
  with DT do
  begin
    _GetDate(Day,  Month, Year);
    _GetTime(Hour, Min,   Sec);
  end;
end;
{}
function GetCurrentUnixTime: Longint;
var
  DT: DateTime;
  t: Longint;
begin
  GetCurrentDateTime(DT);
  PackUnixTime(DT, t);
  GetCurrentUnixTime := t;
end;
{}
function GetCurrentDosTime: Longint;
var
  DT: DateTime;
  t: Longint;
begin
  GetCurrentDateTime(DT);
  PackTime(DT, t);
  GetCurrentDosTime := t;
end;
{}
function WholeParamStr: String;
{$IfDef VP}
begin
  WholeParamStr := pChar2Str(System.CmdLine);
end;
{$Else}
var
  S: pString;
begin
  S := Ptr(PreFixSeg, $80);
  WholeParamStr := StrUpCase(ParamStr(0))+GetPString(S);
end;
{$EndIf}
{}
function CalcBufSize: Longint;
var
  Size: Longint;
begin
  Size := MaxAvail;
  {$IfDef Dos}
   if Size > $FFF8 then Size := $FFF8;
  {$Else}
   if Size > Size256Kb then Size := Size256Kb;
  {$EndIf}
  CalcBufSize := Size;
end;
{}
procedure ClearIO;
begin
  InOutRes := 0;
  DosError := 0;
end;
{}
procedure ResetIO;
begin
  InOutRes := 0;
end;
{}
function CheckIO: Boolean;
begin
  CheckIO := (InOutRes = 0);
end;
{ͼ}

begin
  ExeDir := GetExeDir;
end.
