{
 Macroses' replaces stuff

 (c) 1999-2000 Diman Petrov [2:5023/11.85, DimanInc@mail.ru]

 history:
 ~~~~~~~
 [12/02/00] - first version
}
{&LocInfo+}
{$B-,D+,F-,I-,L+,R-,V-}
Unit Dp_Macro;

interface

uses
  Dp_Basis, Dp_Comn,
  Objects;

type
{ * tMacro * }
{ͻ}
  pMacro = ^tMacro;
  tMacro = record
    Source: pString;
    Dest: pString;
    CS: Boolean;
  end;
{ͼ}

{ * tMacroCollection * }
{ͻ}
  pMacroCollection = ^tMacroCollection;
  tMacroCollection = object(tCollection)
    procedure FreeItem(Item: Pointer); virtual;
    function IndexOf(Item: Pointer): xInt; virtual;
  end;
{ͼ}

{ * tMacros * }
{ͻ}
  pMacros = ^tMacros;
  tMacros = object(tObject)
    M: pMacroCollection;
    constructor Init;
    destructor  Done; virtual;

    function    Add(const Src, Dst: String; CS: Boolean): xInt;
                           { returns the index of added macro }
    procedure   ChangeSrc(Index: xInt; const Src: String);
    procedure   ChangeDst(Index: xInt; const Dst: String);
    procedure   ChangeCS (Index: xInt; CS: Boolean);

    function    ProcessString(S: String): String;
    procedure   ProcessStringEx(var S: String);
  end;
{ͼ}

{}
{}
{}

implementation

{ * tMacroCollection * }
{ͻ}
procedure tMacroCollection.FreeItem(Item: Pointer);
var
  p: pMacro absolute Item;
begin
  if p = nil then Exit;

  DisposeStr(p^.Source);
  DisposeStr(p^.Dest);
  Dispose(p);
end;
{}
function tMacroCollection.IndexOf(Item: Pointer): xInt;
var
  i: xInt;
  p: pMacro absolute Item;
begin
  IndexOf := -1;
  for i := 0 to pred(Count) do
    if pMacro(Items^[i])^.Source^ = p^.Source^ then
    begin
      IndexOf := i;
      Break;
    end;
end;
{ͼ}

{ * tMacros * }
{ͻ}
constructor tMacros.Init;
begin
  inherited Init;

  M := New(pMacroCollection, Init($10, $10));
end;
{}
destructor tMacros.Done;
begin
  Dispose(M, Done);

  inherited Done;
end;
{}
function tMacros.Add(const Src, Dst: String; CS: Boolean): xInt;
var
  p: pMacro;
begin
  New(p);

  p^.Source := NewStr(Src);
  if Dst <> #0 then p^.Dest := NewStr(Dst)
  else p^.Dest := NewStr(Src);
  p^.CS     := CS;

  M^.Insert(p);
  Add := pred(M^.Count);
end;
{}
procedure tMacros.ChangeSrc(Index: xInt; const Src: String);
begin
  if Index > M^.Count then Exit;

  DisposeStr(pMacro(M^.Items^[Index])^.Source);
  pMacro(M^.Items^[Index])^.Source := NewStr(Src);
end;
{}
procedure tMacros.ChangeDst(Index: xInt; const Dst: String);
begin
  if Index > M^.Count then Exit;

  DisposeStr(pMacro(M^.Items^[Index])^.Dest);
  pMacro(M^.Items^[Index])^.Dest := NewStr(Dst);
end;
{}
procedure tMacros.ChangeCS(Index: xInt; CS: Boolean);
begin
  if Index > M^.Count then Exit;

  pMacro(M^.Items^[Index])^.CS := CS;
end;
{}
function tMacros.ProcessString(S: String): String;
  procedure ReplaceIt(p: pMacro); far;
  begin
    if (p^.Source = nil)or(p^.Dest = nil) then Exit;

    if p^.CS then StrReplaceCSEx(S, p^.Source^, p^.Dest^)
    else StrReplaceEx(S, p^.Source^, p^.Dest^);
  end;
begin
  M^.ForEach(@ReplaceIt);
  ProcessString := S;
end;
{}
procedure tMacros.ProcessStringEx(var S: String);
begin
  S := ProcessString(S);
end;
{ͼ}

end.
