{
 Posting files [UUE, Text, Cut Text]
      [ made on the basis of unit Encoder (c) by sergey korowkin, 2:6033/27 ]

 (c) 1999-2000 Diman Petrov [2:5023/11.85, DimanInc@mail.ru]

 note: it was tested not very hard, so here may be some bugs
}
{&LocInfo+}
{$B-,D+,I-,L+,R-}
Unit Dp_Post;

interface

uses
  Dp_Basis, Dp_Comn, Dp_Stuff,
  Objects;

const
  pfDisposeSource       = $00000001;
  pfLinesInsteadOfBytes = $00000002;

  pfDefault             = $00000000;

type
  TPostMode = (pmUUE, pmText, pmCutText);

{ * TPosterBasis * }
{ͻ}
  PPosterBasis = ^TPosterBasis;
  TPosterBasis = object(TObject)
    Source: PStream;
    FName: String;
    Mode: TPostMode;
    Flags, CurrentSection, TotalSections, Line, LinesPerSection: Longint;

    constructor Init(const ASource: PStream;
                     const AFName: String;
                     const AMode: TPostMode;
                     const AFlags, ALimit: Longint);
    destructor  Done; virtual;
    function    Post: Boolean;
   public
    procedure   CreateSection; virtual;
    procedure   CloseSection; virtual;
    procedure   AddLine(S: String); virtual;
    procedure   AddBuffer(Buf: Pointer; Count: Longint); virtual;
    function    Id: String; virtual;
   private
    SourceSize, SourcePos: Longint;
    SourceEOF: Boolean;

    procedure   Prepare; virtual;
    procedure   GetLine(var S: String);
    procedure   GetBuffer(var Buf: Pointer; Count: Longint; var NumRead: Longint);
    procedure   PrepareText;
    function    PostUUE: Boolean;
    function    PostText: Boolean;
    function    PostCutText: Boolean;
  end;
{ͼ}

{}
{}
{}

implementation

{ * TPosterBasis * }
{ͻ}
constructor TPosterBasis.Init(const ASource: PStream;
                              const AFName: String;
                              const AMode: TPostMode;
                              const AFlags, ALimit: Longint);
begin
  inherited Init;

  Source    := ASource;
  Mode      := AMode;
  Flags     := AFlags;

  if Mode = pmUUE then
    if Flags and pfLinesInsteadOfBytes = 0
    then LinesPerSection := ALimit div 61   { old value = 45 }
    else LinesPerSection := ALimit
  else LinesPerSection := ALimit;

  if LinesPerSection < 10 then LinesPerSection := 10;
  if (LinesPerSection > 1000)and(Flags and pfLinesInsteadOfBytes <> 0)
  then LinesPerSection := 1000;

  FName := Path2NameExt(AFName);

  if FName[Length(FName)] = '.' then Delete(FName, Length(FName), 1);
  if FName = '' then FName := 'untitled';
  ReplaceCharEx(FName, ' ', '_');

  Prepare;
end;
{}
destructor TPosterBasis.Done;
begin
  if Flags and pfDisposeSource <> 0 then Dispose(Source, Done);

  inherited Done;
end;
{}
function TPosterBasis.Post: Boolean;
begin
  CurrentSection := 0;

  case Mode of
    pmUUE     : Post := PostUUE;
    pmText    : Post := PostText;
    pmCutText : Post := PostCutText;
  end;
end;

{ * Abstract methods * }
{}
procedure TPosterBasis.CreateSection;
begin
  Abstract;
end;
{}
procedure TPosterBasis.CloseSection;
begin
  Abstract;
end;
{}
procedure TPosterBasis.AddLine(S: String);
begin
  Abstract;
end;
{}
procedure TPosterBasis.AddBuffer(Buf: Pointer; Count: Longint);
begin
  Abstract;
end;
{}
function TPosterBasis.Id: String;
begin
  Abstract;
end;

{ * Private methods * }
{}
procedure TPosterBasis.Prepare;
var
  i: Longint;
  S: String;
begin
  Source^.Reset;
  Source^.Seek(0);

  case Mode of
    pmUUE     : TotalSections := _Trunc( _Trunc(Source^.GetSize / 45 + 1)
                                         / LinesPerSection );
    pmText    : begin
                  TotalSections := 1;
                  PrepareText;
                end;
    pmCutText : begin
                  PrepareText;

                  TotalSections := 1;
                  i := 0;

                  if Flags and pfLinesInsteadOfBytes <> 0
                  then while not SourceEOF do
                       begin
                         GetLine(S);
                         inc(i);

                         if i >= LinesPerSection then
                         begin
                           i := 0;
                           inc(TotalSections);
                         end;
                       end
                  else while not SourceEOF do
                       begin
                         GetLine(S);
                         inc(i, Length(S) + 2);

                         if i >= LinesPerSection then
                         begin
                           i := 0;
                           inc(TotalSections);
                         end;
                       end;

                  PrepareText;
                end;
  end;
end;
{}
procedure TPosterBasis.GetLine(var S: String);
var
  Count, Shift : Word;
  Difference   : Longint;
begin
  Count := pred(SizeOf(S));
  Difference := SourceSize - SourcePos;

  if Difference <= 0 then
  begin
    SourceEOF := True;
    S := '';
    Exit;
  end;

  if Count > Difference then Count := Difference;

  Source^.Read(S[1], Count);
  SetLength(S, Count);

  SetLength(S, Pos(CR, S));

  if Length(S) <> 0 then
  begin
    Shift := Length(S);
    if S[Length(S) + 1] = LF then Inc(Shift);
    Delete(S, Length(S), 1);
  end
  else
  begin
    SourceEOF := True;
    Shift := Count;
    SetLength(S, Count);
  end;

  inc(SourcePos, Shift);
  Source^.Seek(SourcePos);
end;
{}
procedure TPosterBasis.GetBuffer(var Buf: Pointer; Count: Longint; var NumRead: Longint);
var
  Shift      : Word;
  Difference : Longint;
begin
  Difference := SourceSize - SourcePos;

  if Difference <= 0 then
  begin
    SourceEOF := True;
    Buf := nil;
    NumRead := 0;
    Exit;
  end;

  if Count > Difference then Count := Difference;

  GetMem(Buf, Count);
  Source^.Read(Buf^, Count);

  NumRead := Count;

  inc(SourcePos, Count);
  Source^.Seek(SourcePos);
end;
{}
procedure TPosterBasis.PrepareText;
begin
  Source^.Reset;
  Source^.Seek(0);

  SourceSize := Source^.GetSize;
  SourcePos  := Source^.GetPos;
  SourceEOF  := False;
end;
{}
function TPosterBasis.PostUUE: Boolean;
var
  FileCRC, SectionCRC: Word;
  SectionSize, Countdown, i, X, Y, Z: Longint;
  BufferSize: Integer;
  Buffer: Array[1..45] of Byte;
  S: String;

 function CalcCRC(Crc: Word; NextByte: Byte): Word; assembler;
 asm
   mov ax,crc
   ror ax,1
   mov cl,nextbyte
   xor ch,ch
   add ax,cx
 end;

 procedure CalcString(const S: String);
 var
   i: Byte;
 begin
   for i := 1 to Length(S) do SectionCRC := CalcCRC(SectionCRC, Byte(S[i]));
   SectionCRC := CalcCRC(SectionCRC, $0A);
   Inc(SectionSize, succ(Length(S)));
 end;

 procedure OpenTheSection;
 var
   S: String;
 begin
   SectionCRC  := 0;
   SectionSize := 0;

   Line := 0;

   CreateSection;
   Inc(CurrentSection);

   AddLine( Concat('section ', N2Str(CurrentSection), ' of ',
                   N2Str(TotalSections), ' of file ', FName, ' ', Id, NL) );

   if CurrentSection = 1 then
   begin
     S := Concat('begin 644 ', FName);
     AddLine(S);
     CalcString(S);
   end;
 end;

 procedure CloseTheSection;
 var
   S: String;
 begin
   if CurrentSection = TotalSections then
   begin
     S := '`';
     AddLine(S);
     CalcString(S);
     S := 'end';
     AddLine(S);
     CalcString(S);
   end;

   if TotalSections = 1
   then S := '(from "begin" to "end")'
   else if CurrentSection = 1
        then S := '(from "begin" to last encoded line)'
        else S := '(from first to last encoded line)';

   AddLine( Concat('sum -r/size ', N2Str(SectionCRC), '/',
                   N2Str(SectionSize), ' section ', S) );

   if CurrentSection = TotalSections then
     AddLine( Concat('sum -r/size ', N2Str(FileCRC), '/',
              N2Str(Source^.GetSize), ' entire input file') );

   CloseSection;
 end;

 procedure AddChar(Ch: Byte);
 begin
   if Ch = 0 then Ch := 96
             else Inc(Ch, 32);
   SetLength(S, succ(Length(S)));

   S[Length(S)] := Char(Ch);
 end;

begin
  PostUUE := True;
  FileCRC := 0;
  OpenTheSection;
  Countdown := Source^.GetSize;

  repeat
    if Countdown <= 0 then Break;

    BufferSize := SizeOf(Buffer);
    if BufferSize > Countdown then BufferSize := Countdown;

    Source^.Read(Buffer, BufferSize);
    dec(Countdown, BufferSize);

    for i := 1 to BufferSize do FileCRC := CalcCRC(FileCRC, Buffer[i]);

    S := Char(BufferSize + 32);

    X := _Trunc(BufferSize / 3);
    Y := Trunc(BufferSize / 3);
    Z := BufferSize mod 3;

    for i := 1 to X do
      if (BufferSize = 45)or(i <> X)or((i = X)and(Z = 0)) then
      begin
        AddChar(Buffer[(i - 1) * 3 + 1] shr 2);
        AddChar(Buffer[(i - 1) * 3 + 1] and $03 shl 4 + Buffer[(i - 1) * 3 + 2] shr 4);
        AddChar(Buffer[(i - 1) * 3 + 2] and $0F shl 2 + Buffer[(i - 1) * 3 + 3] shr 6);
        AddChar(Buffer[(i - 1) * 3 + 3] and $3F);
      end else
      begin
        AddChar(Buffer[(i - 1) * 3 + 1] shr 2);
        AddChar(Buffer[(i - 1) * 3 + 1] and $03 shl 4 + Buffer[(i - 1) * 3 + 2] shr 4);

        if (BufferSize - 3 * Trunc(BufferSize / 3)) = 2 then
          AddChar(Buffer[(i - 1) * 3 + 2] and $0F shl 2 + Buffer[(i - 1) * 3 + 3] shr 6);
      end;

    AddLine(S);
    CalcString(S);
    inc(Line);

    if Line = LinesPerSection then
    begin
      CloseTheSection;
      OpenTheSection;
    end;
  until False;

  CloseTheSection;
end;
{}
function TPosterBasis.PostText: Boolean;
var
  Size, Res: Longint;
  Buf: Pointer;
begin
  PostText := True;
  CreateSection;

  while not SourceEOF do
  begin
    Size := CalcBufSize;
    GetBuffer(Buf, Size, Res);
    AddBuffer(Buf, Res);
    if Buf <> nil then FreeMem(Buf, Res);
  end;

  CloseSection;
end;
{}
function TPosterBasis.PostCutText: Boolean;
var
  S: String;
  i: Longint;

 procedure OpenTheSection;
 begin
   CreateSection;
   Inc(CurrentSection);

   Line := 0;
 end;
 procedure CloseTheSection;
 begin
   CloseSection;
 end;

begin
  PostCutText := True;
  i := 0;
  OpenTheSection;

  while not SourceEOF do
  begin
    GetLine(S);
    AddLine(S);
    Inc(Line);
    Inc(i, Length(S) + 2);

    if ((Flags and pfLinesInsteadOfBytes <> 0)and(Line >= LinesPerSection))or
       ((Flags and pfLinesInsteadOfBytes =  0)and(i >= LinesPerSection))
    then begin
           CloseTheSection;
           OpenTheSection;
           i := 0;
         end;
  end;

  CloseTheSection;
end;
{ͼ}

end.
