{
 Text screen stuff (only for 80x25 mode, I think =)

 (c) 1999-2000 Diman Petrov [2:5023/11.85, DimanInc@mail.ru]

 history:
 ~~~~~~~
 [08/01/00] - GetText rewritten
 [16/01/00] - GotoXY, ScrollUp, ScrollDown added
              WritePChar removed
}

{$IFDEF MSDOS} {$DEFINE DOS} {$ENDIF}
{$IFDEF DPMI}  {$DEFINE DOS} {$ENDIF}

{$IFNDEF DOS}
  !!! ERROR: This unit is not compatible with non-DOS applications !!!
{$ENDIF}

{$B-,V-}
Unit Dp_Scr;

interface

uses
  Dp_Basis;

const
  Black         = 0;  {00h}
  Blue          = 1;  {01h}
  Green         = 2;  {02h}
  Cyan          = 3;  {03h}
  Red           = 4;  {04h}
  Magenta       = 5;  {05h}
  Brown         = 6;  {06h}
  LightGray     = 7;  {07h}
  DarkGray      = 8;  {08h}
  LightBlue     = 9;  {09h}
  LightGreen    = 10; {0Ah}
  LightCyan     = 11; {0Bh}
  LightRed      = 12; {0Ch}
  LightMagenta  = 13; {0Dh}
  Yellow        = 14; {0Eh}
  White         = 15; {0Fh}

var
  Attr: Byte;

type
  tCharAttrRec = record
    Ch  : System.Char;
    Attr: System.Byte;
  end;
  tScreen = Array[1..25,1..80]of TCharAttrRec;

  tPointRec = record
    X, Y: Byte;
  end;

  tRectRec = record
    A, B: TPointRec;
  end;

var
  Screen: tScreen absolute $B800:$0000;

procedure Delay(Time: Longint);
procedure Cls;
procedure CursorOff;
procedure CursorOn;
procedure SetCursorSize(Up, Down: Byte);
procedure GotoXY(x, y: Byte);
{}
function  GetChar(x, y: Integer): Char;
function  GetAttr(x, y: Integer): Integer;
procedure GetText(var Buf: pChar; x1, y1, x2, y2: Integer);
{}
procedure WriteCh(x, y: Integer; Ch: Char);
procedure WriteStr(x, y: Integer; S: String);
{}
procedure ScrollUp(LinesCount, Attribute: Byte; Coords: tRectRec);
procedure ScrollDown(LinesCount, Attribute: Byte; Coords: tRectRec);
{}
function  CheckXY(x, y: Integer): Boolean;
procedure ParseAttr(const Attr: Byte; var TextC, BackGrC: Byte);
function  Cvt2Attr(const TextC, BackGrC: Byte): Byte;
procedure RectAssign(var R: tRectRec; const AX, AY, BX, BY: Byte);
{}
procedure SetColor(Color: Byte);
procedure SetBackGround(Color: Byte);
{}
procedure Frame(Color: Byte);

{}
{}
{}

implementation

{ͻ}
procedure Delay(Time : LongInt); assembler;
asm
  mov ah,86h
  mov dx,word ptr Time
  mov cx,word ptr Time+2
  int 15h
end;
{}
procedure Cls; assembler;
asm
  mov ax,3
  int 10h
end;
{}
procedure CursorOff; assembler;
asm
  mov ah,1
  mov ch,20h
  int 10h
end;
{}
procedure CursorOn; assembler;
asm
  mov ah,1
  mov cx,607h
  int 10h
end;
{}
procedure SetCursorSize(Up, Down: Byte); assembler;
asm
  mov ah,1
  mov ch,Up
  mov cl,Down
  int 10h
end;
{}
procedure GotoXY(x, y: Byte); assembler;
asm
  mov ah,0Fh
  int 10h
  mov ah,02h
  mov dl,x
  mov dh,y
  int 10h
end;
{}
function GetChar(x, y: Integer): Char;
begin
  If not CheckXY(x, y) Then begin GetChar := #0; Exit end;
  GetChar := Screen[y, x].Ch;
end;
{}
function GetAttr(x, y: Integer): Integer;
begin
  If not CheckXY(x, y) Then begin GetAttr := -1; Exit end;
  GetAttr := Screen[y, x].Attr;
end;
{}
procedure GetText(var Buf: pChar; x1, y1, x2, y2: Integer);
var
  X, Y, I: Integer;
begin
  Buf  := Nil;
  Buf^ := #0;

  if X1 < 1  then X1 := 1;
  if Y1 > 1  then Y1 := 1;
  if X2 > 80 then X2 := 80;
  if Y2 > 25 then Y2 := 25;
  if (X1 > X2)or(Y1 > Y2) then Exit;

  GetMem(Buf, (X2 - X1 + 1) * (Y2 - Y1 + 1) + 1);
  I := 0;

  for Y := Y1 to Y2 do
    for X := X1 to X2 do
    begin
      Buf[I] := Screen[Y, X].Ch;
      Inc(I);
    end;

  Buf[I] := #0;
end;
{}
procedure WriteCh(x, y: Integer; Ch: Char);
begin
  If not CheckXY(x, y) Then Exit;
  Screen[y, x].Ch := Ch;
  Screen[y, x].Attr := Attr;
end;
{}
procedure WriteStr(x, y: Integer; S: String);
var
  i: Byte;
begin
  If not CheckXY(x, y) Then Exit;
  For i := 1 to Length(S) do
  begin
    Screen[y, Pred(x+i)].Ch   := S[i];
    Screen[y, Pred(x+i)].Attr := Attr;
  end;
end;
{}
procedure ScrollUp(LinesCount, Attribute: Byte; Coords: TRectRec); assembler;
asm
  mov ah,06h            {up}
  mov al,LinesCount     {- ப  ஫}
  mov bh,Attribute      {ਡ   ᢮襣 }
  mov ch,Coords.A.X     { 孥 ப  }
  mov cl,Coords.A.Y     {   ⮫ }
  mov dh,Coords.B.X     {   ப  }
  mov dl,Coords.B.Y     { ࠢ ⮫ }

  int 10h
end;
{}
procedure ScrollDown(LinesCount, Attribute: Byte; Coords: TRectRec); assembler;
asm
  mov ah,07h            {down}
  mov al,LinesCount     {- ப  ஫}
  mov bh,Attribute      {ਡ   ᢮襣 }
  mov cl,Coords.A.X     {   ⮫ }
  mov ch,Coords.A.Y     { 孥 ப  }
  mov dl,Coords.B.X     { ࠢ ⮫ }
  mov dh,Coords.B.Y     {   ப  }

  int 10h
end;
{}
function CheckXY(x, y: Integer): Boolean;
begin
  CheckXY := ( x in [1..80] ) and ( y in [1..25] );
end;
{}
procedure ParseAttr(const Attr: Byte; var TextC, BackGrC: Byte);
begin
  TextC   := Attr and $F;
  BackGrC := Attr shr 4;
end;
{}
function Cvt2Attr(const TextC, BackGrC: Byte): Byte;
begin
  Cvt2Attr := TextC + (BackGrC shl 4);
end;
{}
procedure RectAssign(var R: TRectRec; const AX, AY, BX, BY: Byte);
begin
  with R do
  begin
    A.X := AX;
    A.Y := AY;
    B.X := BX;
    B.Y := BY;
  end;
end;
{}
procedure SetColor(Color: Byte);
begin
  if Color > White then Color := (Color and $0F) or $80;

  Attr := (Attr and $70) or Color;
end;
{}
procedure SetBackGround(Color: Byte);
begin
  Attr := (Attr and $8F) or ((Color and $07) shl 4);
end;
{}
procedure Frame(Color: Byte); Assembler;
asm
  mov ah,10h
  mov al,01h
  mov bh,Color
  int 10h
end;
{ͼ}

begin
  Attr := $07; {LightGray on Black}
end.
