{
 Other stuff

 (c) 1999-2000 Diman Petrov [2:5023/11.85, DimanInc@mail.ru]

 history:
 ~~~~~~~
 [16/01/00] - MonState added [(c) by raVen, 2:5010/150.16]
 [19/01/00] - Pow and IntPow fixed
 [16/03/00] - IsSimple was added
 [26/03/00] - Str2Kbrd was added (DOS version (q) by raVen, 2:5010/150.16,
                                  VP version (c) by me :)
}
{&LocInfo+}
{$B-,D+,G+,I-,L+,N+,R-,V-}
Unit Dp_Stuff;

interface

uses
  Dp_Basis,
  Dos, Strings;

const
  OnMon   = 00;
  StandBy = 01;
  Suspend = 02;
  Off     = 04;
  RedOn   = 08; {reduced On (for flat screens)}

{}
procedure SecondsToTime(Seconds: Longint; var DT: DateTime);
procedure TimeToSeconds(var Seconds: Longint; const DT: DateTime);
{}
function  Pow(X, S: Extended): Extended;
function  IntPow(X, S: Integer): Longint;
function  _Trunc(N: Real): Longint;
function  IsSimple(X: Longint): Boolean;
{}
function  CheckMem(Bytes: Longint): Boolean;
procedure MonState(State: Byte);
{[ Keyboard stuff ]}
procedure Str2kbrd(S: String);

{}
{}
{}

implementation

{ͻ}
procedure SecondsToTime(Seconds: Longint; var DT: DateTime);
begin
  with DT do
  begin
    Hour := Seconds div 3600;
      Dec(Seconds, 3600 * Longint(Hour));
    Min  := Seconds div 60;
      Dec(Seconds, 60 * Longint(Min));
    Sec  := Seconds;
  end;
end;
{}
procedure TimeToSeconds(var Seconds: Longint; const DT: DateTime);
begin
  with DT do
  begin
    Seconds := Longint(Hour) * 3600 +
               Longint(Min) * 60 +
               Longint(Sec);
  end;
end;
{}
function Pow(X, S: Extended): Extended;
begin
  if S = 0 then
    if X <> 0 then Pow := 1
    else Pow := 0
  else Pow := Exp(S * Ln(X));
end;
{}
function IntPow(X, S: Integer): Longint;
begin
  if S = 0 then
    if X <> 0 then IntPow := 1
    else IntPow := 0
  else IntPow := Round(Exp(S * Ln(X)));
end;
{}
function _Trunc(N: Real): Longint;
var
  L: Longint;
begin
  L := Trunc(N);
  if L <> N then Inc(L);
  _Trunc := L;
end;
{}
function IsSimple(X: Longint): Boolean;
var
  i: Longint;
begin
  IsSimple := True;
  for i := 2 to (X shr 1) do
    if (X mod i = 0) then
    begin
      IsSimple := False;
      Break;
    end;
end;
{}
function CheckMem(Bytes : Longint): Boolean;
begin
  CheckMem := Bytes < MaxAvail;
end;
{}
procedure MonState(State: Byte);
{$IfDef VirtualPascal}
const
  MonState: pChar = #$B8#$10#$4F#$B3#$01#$B7#$00#$CD#$10#$C3;
  fName: pChar = 'MonState.com';
var
  F: File;
begin
  MonState[6] := Char(State);

  Assign(F, StrPas(fName)); Rewrite(F, 1);
  BlockWrite(F, MonState^, 10); Close(F);

  Exec(StrPas(fName), '');

  Erase(F);
end;
{$Else}
assembler;
asm
  mov ax,04F10h
  mov bl,1
  mov bh,State
  int 10h
end;
{$EndIf}
{}
procedure Str2kbrd(S: String);
{$IfDef VirtualPascal}
const
  Every:  pChar = #$B4#$05#$B1#$00#$CD#$16;
  Finish: pChar = #$B4#$4C#$B0#$00#$CD#$21;
  FName:  pChar = 'ToKbrd.com';
var
  F: File;
  i: Longint;
begin
  Assign(F, StrPas(FName));
  Rewrite(F, 1);

{  S := Concat(S, CR);}

  for i := 1 to Length(S) do
  begin
    Every[3] := S[i];
    BlockWrite(F, Every^, 6);
  end;

  BlockWrite(F, Finish^, 6);

  Close(F);

  Exec(StrPas(FName), '');
  Erase(F);
end;
{$Else}
{ * (q) by raVen, 2:5010/150.16 * }
var
  Regs: Dos.Registers;
  x: Byte;
  BufferFull: Boolean;
begin
{  Inc(S[0]);
  S[Length(S)] := CR;}
  x := 1;
  repeat
    Regs.AH := $05;
    Regs.CL := Byte(S[x]);
    Intr($16, Regs);
    BufferFull := Boolean(Regs.AL);
    Inc(x);
  until (BufferFull) or (x > Byte(S[0]));
 end;
{ * End of: (q) by raVen, 2:5010/150.16 * }
{$EndIf}
{ͼ}

end.
