{
 Some stuff for skMHL library (q) by sergey korowkin [2:6033/27@fidonet]

 (c) 2000 Diman Petrov [2:5023/11.85, DimanInc@mail.ru]

 history:
 ~~~~~~~
 [26/04/00] - mhlSetAttributes was added
 [28/04/00] + mhlCheckAttributes
}
{$V-,X+}
{&H-}
unit mhlStuff;

interface

uses
  Dos,
  Dp_Basis, Dp_Comn,
  skCommon, skMHL, skMHLmsg;

const
  MaxNameLen = 35;
  MaxSubjLen = 71;
  MaxStrLen  = 79;

  sPIDKludge = #1'PID:';

  sTagline   = '...';
  sTearline  = '---';
  sOrigin    = ' * Origin:';

  sPrivate   = 'PVT';
  sCrash     = 'CRA';
  sReceived  = 'RCV';
  sSent      = 'SNT';
  sAttach    = 'ATT';
  sTransit   = 'TRS';
  sOrphan    = 'ORP';
  sKill      = 'K/S';
  sLocal     = 'LOC';
  sHold      = 'HLD';
  sFRq       = 'FRQ';
  sRRq       = 'RRQ';
  sRRc       = 'RRC';
  sARq       = 'ARQ';
  sURq       = 'URQ';
  sScanned   = 'SCN';

{[ for all styles ]}
procedure mhlGenerateMsg(var MB: tMessageBase;
                         const FromName, ToName, Subject: String;
                         FromAddress, ToAddress: pAddress;
                         const Pid: String
                        );
function  mhlSetAttributes(var MB: tMessageBase; const S: String): xByte;
function  mhlCheckAttributes(const S: String): xByte;
function  mhlCopyMessage(var Src, Dst: tMessageBase; N: Longint): Boolean;
procedure mhlPutTagline(var MB: tMessageBase; const Text: String);
procedure mhlPutTearline(var MB: tMessageBase; const Text: String);
{[ only for MSG ]}
function  mhlRenumber(var fMB: tFidoMessageBase): Boolean;
function  mhlGetSize(var fMB: tFidoMessageBase; Message: Longint): Longint;
{}

{}
{}
{}

implementation

{ͻ}
function mhlStreamEOF(var S: tMessageBaseStream): Boolean;
begin
  mhlStreamEOF := (S.GetPos = S.GetSize);
end;
{ͼ}

{ͻ}
procedure mhlGenerateMsg(var MB: tMessageBase;
                         const FromName, ToName, Subject: String;
                         FromAddress, ToAddress: pAddress;
                         const Pid: String
                        );
begin
  with MB do
  begin
    if FromName <> #0 then SetFrom(StrTrunc(FromName, MaxNameLen));
    if ToName   <> #0 then SetTo  (StrTrunc(ToName,   MaxNameLen));
    if Subject  <> #0 then SetSubject(StrTrunc(Subject, MaxSubjLen));

    if FromAddress <> nil then SetFromAddress(FromAddress^, True);
    if ToAddress   <> nil then SetToAddress(ToAddress^);

    if Pid <> #0 then SetKludge(sPIDKludge, Concat(sPIDKludge,' ',Pid));

    ResetDateTime;
  end;
end;
{}
function mhlSetAttributes(var MB: tMessageBase; const S: String): xByte;
var
  i: xByte;
  S3: String[3];
begin
  mhlSetAttributes := 0;

  for i := 1 to WordCount(S, SpaceCh) do
  begin
    S3 := WordExtract(S, SpaceCh, i);
    StrUpCaseEx(S3);

    if S3 = sPrivate  then begin MB.SetAttribute(maPrivate,  True); Continue end;
    if S3 = sCrash    then begin MB.SetAttribute(maCrash,    True); Continue end;
    if S3 = sReceived then begin MB.SetAttribute(maReceived, True); Continue end;
    if S3 = sSent     then begin MB.SetAttribute(maSent,     True); Continue end;
    if S3 = sAttach   then begin MB.SetAttribute(maAttach,   True); Continue end;
    if S3 = sTransit  then begin MB.SetAttribute(maTransit,  True); Continue end;
    if S3 = sOrphan   then begin MB.SetAttribute(maOrphan,   True); Continue end;
    if S3 = sKill     then begin MB.SetAttribute(maKill,     True); Continue end;
    if S3 = sLocal    then begin MB.SetAttribute(maLocal,    True); Continue end;
    if S3 = sHold     then begin MB.SetAttribute(maHold,     True); Continue end;
    if S3 = sFRq      then begin MB.SetAttribute(maFRq,      True); Continue end;
    if S3 = sRRq      then begin MB.SetAttribute(maRRq,      True); Continue end;
    if S3 = sRRc      then begin MB.SetAttribute(maRRc,      True); Continue end;
    if S3 = sARq      then begin MB.SetAttribute(maARq,      True); Continue end;
    if S3 = sURq      then begin MB.SetAttribute(maURq,      True); Continue end;
    if S3 = sScanned  then begin MB.SetAttribute(maScanned,  True); Continue end;

    mhlSetAttributes := i;
    Exit;
  end;
end;
{}
function mhlCheckAttributes(const S: String): xByte;
var
  i: xByte;
  S3: String[3];
begin
  mhlCheckAttributes := 0;

  for i := 1 to WordCount(S, SpaceCh) do
  begin
    S3 := WordExtract(S, SpaceCh, i);
    StrUpCaseEx(S3);

    if (S3 = sPrivate)or
       (S3 = sCrash)or
       (S3 = sReceived)or
       (S3 = sSent)or
       (S3 = sAttach)or
       (S3 = sTransit)or
       (S3 = sOrphan)or
       (S3 = sKill)or
       (S3 = sLocal)or
       (S3 = sHold)or
       (S3 = sFRq)or
       (S3 = sRRq)or
       (S3 = sRRc)or
       (S3 = sARq)or
       (S3 = sURq)or
       (S3 = sScanned) then Continue;

    mhlCheckAttributes := i;
    Exit;
  end;
end;
{}
function mhlCopyMessage(var Src, Dst: tMessageBase; N: Longint): Boolean;
var
  OldPosition, Size: Longint;
  S: String;
  A1, A2: tAddress;
  DT: tMessageBaseDateTime;
begin
  mhlCopyMessage := False;

  OldPosition := Src.Current;

  Src.Seek(N);
  if not Src.OpenMessage then
  begin
    Src.Seek(OldPosition);
    Exit;
  end;

  if not Dst.CreateNewMessage then
  begin
    Src.CloseMessage;
    Src.Seek(OldPosition);
    Exit;
  end;

  S := Src.GetFrom;
  Dst.SetFrom(S);

  S := Src.GetTo;
  Dst.SetTo(S);

  S := Src.GetSubject;
  Dst.SetSubject(S);

  Src.GetFromAndToAddress(A1, A2);
  Dst.SetFromAndToAddress(A1, A2, False);

  GetAttributesLine(@Src, S);
  mhlSetAttributes(Dst, S);

  Src.GetWrittenDateTime(DT);
  Dst.SetWrittenDateTime(DT);

  Src.GetArrivedDateTime(DT);
  Dst.SetArrivedDateTime(DT);

  { doezn't work ;(
  Dst.MessageText^.CopyFrom(Src.MessageText^, Src.MessageText^.GetSize);
  }

  Dst.WriteMessage;
  Dst.CloseMessage;

  Src.CloseMessage;

  Src.Seek(OldPosition);

  mhlCopyMessage := True;
end;
{}
procedure mhlPutTagline(var MB: tMessageBase; const Text: String);
var
  S: String;
begin
  S := Concat(sTagline, #32, Text);

  S := StrTrunc(S, MaxStrLen);

  MB.PutString(S);
end;
{}
procedure mhlPutTearline(var MB: tMessageBase; const Text: String);
var
  S: String;
begin
  S := Concat(sTearline, #32, Text);

  S := StrTrunc(S, MaxStrLen);

  MB.PutString(S);
end;
{}
function mhlRenumber(var fMB: tFidoMessageBase): Boolean;
var
  N, M, i: Longint;
begin
  mhlRenumber := False;

  with fMB do
  begin
    M := GetHighest;

    AddBackSlash(MessageBasePath);

    for N := 1 to M do
    begin
      if not Exists(N) then
      begin
        i := N + 1;

        while (not Exists(i))and(i <= M) do inc(i);

        if i = M + 1 then Break;

        if not fRename(MessageBasePath + N2Str(i) + '.msg',
                       MessageBasePath + N2Str(N) + '.msg') then Exit;

        ReOpen;
      end;
    end;
  end;

  mhlRenumber := True;
end;
{}
function mhlGetSize(var fMB: tFidoMessageBase; Message: Longint): Longint;
var
  SR: Dos.SearchRec;
begin
  with fMB do
  begin
    AddBackSlash(MessageBasePath);
    FindFirst(MessageBasePath+N2Str(Message)+'.msg', AnyFile, SR);
  end;

  if DosError <> 0 then mhlGetSize := -1
  else mhlGetSize := SR.Size;
end;
{ͼ}

end.
